
/* <!-- gef:noTags --> */
/*--%r the following tags "<!--%r" (for HTML sections) */ /*--%r" (for JavaScript 
        sections) indicates sections to be removed from the version of the web 
        page downloaded to the PLC to improve performance;  the end of the section 
        is defined by the end of comment symbol (2 different types);  a tool will 
        be developed to remove these sections */
        
/*--%r Confidentiality, Copyright Section, RCS ID section */
/*--**************************************************************************
 * GE Fanuc North America Inc.
 *
 * This computer program contains confidential and proprietary information
 * of GE Fanuc Automation North America, Inc.  Neither the program nor the
 * information contained therein may be copied or disclosed to any third
 * party without the prior approval of the GE Fanuc Communications Manager.
 * Unauthorized use of the information or program is strictly prohibited.
 *
 * COPYRIGHT (c) 2001   GE FANUC AUTOMATION NORTH AMERICA INC.
 *   Published in only a limited, copyright sense and all rights, including
 *   trade secret rights, are reserved. Unauthorized use of the information
 *   or program is strictly prohibited.
 *****************************************************************************/

/*--***************************************************************************
 * Module: $Id: common_functions.js,v 1.4 2004/08/04 17:37:18 208048073 Exp $
 *****************************************************************************/
/*--%r Start Internationalization Section --*/
/*--%r Common Header Strings */
var PLC_NAME = "PLC Name:";
var PLC_TIME = "PLC Time:";
var STATUS_LINK = "View PLC Status";
var REFERENCE_TABLE_LINK = "View Reference Tables";
var PLC_FAULT_TABLE_LINK = "View PLC Fault Table";
var IO_FAULT_TABLE_LINK = "View I/O Fault Table";


/*--%r Dialog Strings */
var APPLICATION_ERROR = "JavaScript application or Browser error.";
var BROWSER_WARNING_MESSAGE = "This web page requires Microsoft Internet Explorer 4.0 or greater, or Netscape 4.0 or greater";
var PLC_TIMEOUT = "The PLC did not respond within the timeout period";

/*--%r End Internationalization Section */

/*--%r Common constants */

/*--%r General Constants */
var OK = 0;
var ERROR = -1;

/*--%r 
 * SCAN_TIMEOUT indicates time to wait before asking user if they want to continue
 * units are in milliseconds;
 */ 
var SCAN_TIMEOUT = 15000;


/*--%r HTML Header contants */
var PC_DATE_ID = "pc_date_id";
var PLC_NAME_ID = "plc_name_id";

/*--%r Constants Associated with global variable "browser_type" */
var IE = "Microsoft Internet Explorer";
var NETSCAPE = "Netscape";
var OTHER_BROWSER = "Other Browser";

/*--%r Constants Associated with global variable "browser_version" */
var MIN_BROWSER_VERSION_IE = 4.0;
var MIN_BROWSER_VERSION_NETSCAPE = 4.0;

/*--%r Constant associated with date formatting */
var DATE_SEP = "-";
var TIME_SEP = ":";

/*--%r Common Cookie related constants */
var COOKIE_SAVE_DATE = "expires=Sun, 31-Dec-2023 05:00:00 GMT";
var COOKIE_DELETE_DATE = "expires=Fri, 02-Jan-1970 00:00:00 GMT";

/*--%r Common Header contants */
var PLC_NAME_TEXTBOX = "plc_name_textbox";

/*--%r Common Formatting constants */
var DELTA_CHAR_CODE = 0x2206; /*--%r 0x2206 is unicode for a delta character */
 
/*--%r Common Global Variables */
 /*--%r PC date variables */
var date_obj = new Date(); /*--%r object to hold the date & time information */


/*--%r browser environment variables */
var browser_type = OTHER_BROWSER;
var browser_version = 0;
var browser_refresh = false;

var init_complete = false; /*--%r used to indicate if initialization is complete so that other functions can start */
var cookies_enabled = false; /*--%r indicates whether the browser supports cookies */
var PLC_Date =" "; /*--%r a string variable that contains the formatted PLC date/time */
var PLC_Name = " ";

 /*--%r Common Utility functions for CPU374 Web Pages */
 
 /*--%r***************************************************************************
* Function    : resizeWindow
*
* Description : this function refreshes the Window in Netscape if the window
*               is resized.  This is necessary because Netscape does
*               not properly draw the elements when the window is resized.
*
* Inputs      : the Netscape event object is passed to the function
*
* Outputs     : None.
*
* Modified
* Global Data : None
*
* Global Data
* Accessed:     browser_type, init_complete   
*
****************************************************************************/

function resizeWindow(event)
{
    /*--%r
     * IF the browser type is NETSCAPE and initialization is complete
     *     reload the page so that it is displayed properly
     * ENDIF the browser type is NETSCAPE and initialization is complete
     */
    if ((browser_type == NETSCAPE)&&(init_complete))
    {
        location.reload();
    }
}

/*--%r***************************************************************************
* Function    : refreshPCDate
*
* Description : this function updates the date_obj with the latest date and time
*               and uses the date_obj to update the PC_date global variable with
*               the new time.  
*
* Inputs      : None
*
* Outputs     : None 
*
* Modified
* Global Data : date_obj, PC_date
*
* Global Data
* Accessed:   : DATE_SEP and TIME_SEP constants    
*
****************************************************************************/
function refreshPCDate()
{

 
}

/*--%r***************************************************************************
* Function    : getFixedTime
*
* Description : this function applies a zero to the front of a time component if
*               the value is less than 10.  For example, if the reported seconds is
*               "1", this function would return "01" so that the time format looks
*               correct.  
*
* Inputs      : time_element - a string representing seconds, minutes or hours
*                 that needs to be fixed up.
*
* Outputs     : returns a string with the a zero added to the front if the time_element
*                 is less that zero. 
*
* Modified
* Global Data : None
*
* Global Data
* Accessed:   : None    
*
***********************************************************************************/ 
function getFixedTime(time_element)
{
    /*--%r 
     * IF the time_element is less than 10
     *    concatenate a "0" to the front of the time_element
     * ENDIF
     * return the new time_element
     */
	if (time_element <10)
	{
		time_element = "0"+ time_element;
	}	
	return time_element;
}

/*--%r***************************************************************************
* Function    : readCookie
*
* Description : This function reads a particular cookie from the window.cookie property.
*
* Inputs      : name - this is the name of the cookie to read
*
* Outputs     : returns a string containing the requested cookie or ERROR if the 
*               requested cookie does not exist.
*
* Modified
* Global Data  
* & Objects   : None.
*
*
****************************************************************************/
function readCookie(name)
{
    var first_char,last_char; /*--%r mark the beginning & ending characters of cookie */

    /*--%r
     * initialize return value to ERROR 
     * IF there is a cookie
     *     Get the entire cookie string and unencode it.
     *     Get the specified cookie from the entire_cookie string
     */
    var return_value = ERROR;
    if (document.cookie != '')
	{
        var entire_cookie = document.cookie;
        first_char = entire_cookie.indexOf(name + "=");

    /*--%r
     *     IF the specified cookie was found
     *         Point the first character past the name and the equal character
     *            (ex. my_name=)
     *         Find the end of the cookie string (look for ";")
     *         IF the end of the cookie is not found
     *             use the end of the entire cookie as the end
     *         ENDIF the end of the cookie is not found
     *         set the return value to the cookie string (based on the first_char
     *             and last_char pointers).
     *     ENDIF the specified cookie was found
     * ENDIF there is no cookie
     * return the return value
     *
     */
        if(first_char != ERROR)
        {
            first_char += name.length + 1;
            last_char = entire_cookie.indexOf(';', first_char);
	        if(last_char == ERROR) 
	        {
	            last_char = entire_cookie.length;
	        }
		    return_value = entire_cookie.substring(first_char, last_char);
        } 
    }
    return return_value; 
}
/*--%r***************************************************************************
* Function    : initCommon
*
* Description : This function carries out initialization functions
*               common to all web pages.  This includes: initializing
*               the default error handler, updating the PC Date and time,
*               and checking the browser type and version.
*              
* Inputs      : None
*
* Outputs     : None
*
* Modified
* Global Data  
* & Objects   : browser_type - reads from browser and stores in variable
*               browser_version - reads from browser and stores in variable
*               browser_refresh - set true if the browser supports dynamic
*                   updates of the user display.
* Global Data
* Accesses:     None.
*
****************************************************************************/
function initCommon()
{
    /*--%r
     * initialize the default error handler
     * update the PC Date and time 
     * get browser type, version, refresh support and store in global variables
     * IF browser type and version do not meet minimum requirements
     *     Put up dialog stating the browser is not supported and list
     *        browsers that are supported.
     * ELSE browser type and version do meet minimum requirements
     *     IF browser type is Internet Explorer
     *         set browser_refresh global variable to true indicating the browser supports dynamic refresh
     *     ENDIF browser type is Internet Explorer
     * ENDIF browser type and version do not meet minimum requirements
     */
    self.onerror = defaultErrorHandler;
    refreshPCDate();
    browser_type = window.navigator.appName;
    browser_version = parseFloat(window.navigator.appVersion.slice(0,4));
    if ((browser_type != IE)&&(browser_type != NETSCAPE))
    {
        browser_type = OTHER_BROWSER;
        alert(BROWSER_WARNING_MESSAGE);
    }
    else
    {
        if (browser_type == IE)
        {
            if (browser_version < MIN_BROWSER_VERSION_IE)
            {
                alert(BROWSER_WARNING_MESSAGE);
            }
            else
            {
                browser_refresh = true;
            }
        }    
        else
        {
            if ((browser_type == NETSCAPE)&&(browser_version < MIN_BROWSER_VERSION_NETSCAPE))
            {
                alert(BROWSER_WARNING_MESSAGE);
            }
         }
    }     
}

/*--%r***************************************************************************
* Function    : cookieTest
*
* Description : This function tests whether cookies can be saved.
*              
* Inputs      : None
*
* Outputs     : returns OK if cookies can be saved and ERROR if they cannot be saved.
*
* Modified
* Global Data  
* & Objects   : document.cookie - a cookie called "test_cookie" with a value of test
*               is saved, read back and then deleted.
* Global Data
* Accesses:     None.
*
****************************************************************************/
function cookieTest()
{
    var test_cookie; /*--%r used to test whether the browser supports cookies */
    /*--%r
     * set status to OK
     * write a test cookie to the PC
     * read back the test cookie
     * IF the cookie could not be read back
     *     set the status to ERROR
     * ELSE the cookie could be read back
     *     IF the test cookie does not equal the value written
     *          set the status to ERROR
     *     ENDIF the test cookie does not equal the value written
     * ENDIF the cookie could not be read back
     * IF the status does not equal error (cookie was already deleted if there was an error)
     *     delete the test cookie
     * ENDIF the status does not equal error
     * return the status
     */
    var status = storeCookie("test_cookie", "test");
    if (status != ERROR)
    {
        document.cookie = "test_cookie=test;"+ COOKIE_DELETE_DATE; /*--%r this deletes a cookie called test_cookie */
    }
    return status;
}
/*--%r***************************************************************************
* Function    : convertToASCII
*
* Description : This function converts a number to an ASCII character per the
*               CPU374 Web Server UIS requirements.  
*              
* Inputs      : hex_number - the number to be converted to ASCII
*
* Outputs     : returns ASCII character(s)
*
* Modified
* Global Data  
* & Objects   : None.
*
* Global Data
* Accesses:     None.
*
****************************************************************************/
function convertToASCII(hex_number)
{
    /*--%r
     * IF the number is unprintable
     *     return a "^" in front of the character and use the character
     *             code for the character 0x40 greater than the numeric
     *             value so the unprintable character can be seen
     * ELSE the number is printable.
     *     IF the number is 127
     *         return a delta symbol (Note: this is for compatibility 
     *                 with Logicmaster)
     *     ELSE the number is not 127
     *         return the ASCII character based on the number
     *     ENDIF the number is 127
     * ENDIF the number is unprintable
     */                           
    if (((hex_number >= 0) && (hex_number <= 31))||((hex_number >= 128)&&(hex_number <= 159)))
    {
        return "^" + String.fromCharCode(hex_number + 64);
    }
    else
    {
        if ((hex_number == 127)&& (browser_type != NETSCAPE))
        {
            return String.fromCharCode(DELTA_CHAR_CODE);
        }
        else
        {    
            return String.fromCharCode(hex_number);
        }
    }
}

/*--%r***************************************************************************
* Function    : defaultErrorHandler
*
* Description : This function simply allows the system to handle errors by returning
*               false.  The self.onerror value is set to this function after
*               another error handler is used temporarily.
*
* Inputs      : msg - this is the error message from the browser for the particular error.
*               url - this is the URL of the page that caused the error
*               line - this is the line number where the error occurred on the web page
*
* Outputs     : This function returns false so that the system error handler will handle
*               the error.
*
* Modified
* Global Data  
* & Objects   : None.
*
*
****************************************************************************/
function defaultErrorHandler(msg, url, line)
{
    return false;  /*--%r informs default error handler to handle the error */
}


/*--%r***************************************************************************
* Function    :storeCookie
*
* Description : This function stores a cookie using the given cookie name and cookie
*               value.  If the cookie is not stored correctly, the cookie is deleted.
*
* Inputs      : cookie_name - the name of the cookie to be stored.
                cookie_value - the value of the cookie to be stored.
*
* Outputs     : Returns OK if the cookie is stored correctly and ERROR if
*                   the cookie is not stored correctly.
*
* Modified
* Global Data  
* & Objects   : None.
*
*
****************************************************************************/
function storeCookie(cookie_name, cookie_value)
{
    /*--%r 
     * set status to OK
     * write the cookie name and cookie value to a cookie with a save cookie date
     * read back the cookie
     * IF the cookie is not there or the value of the cookie does not match the value
     *         written
     *     set the status to ERROR
     *     delete the cookie
     * ENDIF the cookie is not there or ....
     * return the status
     */
     
    var status = OK;
    document.cookie =  cookie_name + "=" + cookie_value + ";" + COOKIE_SAVE_DATE;
    var read_cookie = readCookie(cookie_name);
    if ((read_cookie == ERROR)||(read_cookie != cookie_value))
    {
        status = ERROR;
        document.cookie =  cookie_name + "=" + cookie_value + ";" + COOKIE_DELETE_DATE;
    }
    return status;
}

/*--%r#if debug */
function log_event(msg)
{
    date_obj_log = new Date();
    log_elapsed_time =  date_obj_log.getTime();
    log_elapsed_time = log_elapsed_time - log_start_time;
    log_string += msg + "," + log_elapsed_time.toString() + ";";

    /* Netscape debugging method */
    /*document.refForm.the_text.value += msg +";"*/
}
function log_record(log_textbox)
{
     if(log_textbox != null)
       self.document.refForm.log_textbox.value = log_string;
}


/*--%r#endif */       
       