/* <!-- gef:noTags --> */
/*--%r the following tags "<!--%r" (for HTML sections) */ /*--%r" (for JavaScript 
        sections) indicates sections to be removed from the version of the web 
        page downloaded to the PLC to improve performance;  the end of the section 
        is defined by the end of comment symbol (2 different types);  a tool will 
        be developed to remove these sections. 
        
        Also, the following tag "<!--%r#if" or "/*--%r#if" var_name indicate the script 
        code or HTML statements after the comment should only be included in the file if 
        the comment file stripping program is set to a mode to include var_name statements.  
        The following tag "<!--%r#endif" or "/*--%r#endif" ends the section of script code 
        or HTML statements to include or exclude.  The first planned usage is to use
        the var_name of "debug" so that one can include or exclude debug statements.  However,
        this feature could also be used to include or exclude various features or attributes. 
        */
        
/*--%r Confidentiality, Copyright Section, RCS ID section */
/*--**************************************************************************
 * GE Fanuc North America Inc.
 *
 * This computer program contains confidential and proprietary information
 * of GE Fanuc Automation North America, Inc.  Neither the program nor the
 * information contained therein may be copied or disclosed to any third
 * party without the prior approval of the GE Fanuc Communications Manager.
 * Unauthorized use of the information or program is strictly prohibited.
 *
 * COPYRIGHT (c) 2002   GE FANUC AUTOMATION NORTH AMERICA INC.
 *   Published in only a limited, copyright sense and all rights, including
 *   trade secret rights, are reserved. Unauthorized use of the information
 *   or program is strictly prohibited.
 *****************************************************************************/

/*--***************************************************************************
 * Module: $Id: fault_tables.js,v 1.7 2004/08/05 12:46:54 208048073 Exp $
 *****************************************************************************/
/*--%r Start Internationalization Section */
/*--%r Strings in this section need to be translated to produce a Web page that supports a particular
 *     language
 */

/* Fault action Array */
var FaultActionText = new Array ("Informational" , "Diagnostic", "Fatal") ;
/*--%r Header Strings */
var PLC_FAULT_TABLE_TITLE = "PACSystems RX7i PLC Fault Table Viewer:";
var IO_FAULT_TABLE_TITLE = "PACSystems RX7i I/O Fault Table Viewer:";
var PLC_FAULT_TABLE_BUTTON = "Refresh PLC Fault Table";
var IO_FAULT_TABLE_BUTTON = "Refresh I/O Fault Table";

/*--%r Fault Summary Strings */
var TOTAL_FAULTS_LABEL = "Total Faults";
var TOTAL_FAULTS_DISPLAYED_LABEL = "Total Faults Displayed";
var ENTRIES_OVERFLOWED_LABEL = "Entries Overflowed";
/*--%r WORK_TODO:  need to have two labels; one for MM-dd-YY and one for dd-MM-YY to 
 * support different date formats */
var TABLE_LAST_CLEARED_LABEL = "Table Last Cleared (MM-DD-YY HH:MM:SS)";
var PLC_DATE_TIME_LABEL = "PLC Date/Time During Last Update (MM-DD-YY HH:MM:SS)";

/*--%r Fault Table Strings */
var PLC_FAULT_TABLE_LABEL = "PLC Fault Table";
var LOCATION_LABEL = "Location";
var RACK_SLOT_LABEL = ""; /*--%r removed "(r.s)"; * structure could show more than rack & slot */
var FAULT_DESCRIPTION_LABEL = "Fault Description";
var DATE_TIME_LABEL = "Date/Time";
var IO_FAULT_TABLE_LABEL = "I/O Fault Table";
var CIRC_NO_LABEL = "Circ No.";
var REF_ADDR_LABEL = "Ref. Addr";
var FAULT_CATEGORY_LABEL = "Fault Category";
var FAULT_TYPE_LABEL = "Fault Type";

/*--%r Extra Fault Data Table Strings */
var LONG_SHORT_LABEL = "Long/Short";
var TASK_LABEL = "Task";
var GROUP_LABEL = "Group";
var ACTION_LABEL = "Action";
var ERROR_CODE_LABEL = "Error Code";
var FAULT_EXTRA_DATA_LABEL2 = "Fault Extra Data: ";
var IO_BUS_LABEL = "I/O Bus";
var BUS_LABEL = "Bus Address";
var POINT_LABEL = "Point Address";
var GROUP_LABEL = "Group";
var ACTION_LABEL = "Action";
var CATEGORY_LABEL = "Category";
var TYPE_LABEL = "Type";

/*--%r Extra Fault Control Strings */
var FAULT_EXTRA_DATA_LABEL = "Fault Extra<br>Data";
var FAULT_EXTRA_DATA_FORMAT_LABEL = "Fault Extra&nbsp;<br>Data Format";
var SHOW_ALL_LABEL = "Show All";
var BYTE_LABEL = "Byte";
var WORD_LABEL = "Word";
var ASCII_LABEL = "ASCII";

/*--%r Dialog Strings */
var ASCII_NOT_SUPPORTED = "ASCII format for Fault Extra Data is not supported for Netscape Browser";
var BAD_PLC_FAULT_DATA_MESSAGE = "There was an error in the fault data received from the PLC";
var COOKIE_WARNING_MESSAGE = "This web page relies on reading and writing cookies for enabling the control of the extra fault settings.  If enabling cookies on browser does not resolve the issue, please see the user documentation for additional guidance."
var INIT_MESSAGE = "Initializing Fault Table Web Page";
var SCAN_FAULT_WINDOW_DELETED_MESSAGE = "Error getting updated PLC fault data because scan fault window was closed by another application or by the user.";
var SCAN_TIMEOUT_MESSAGE = "Getting updated PLC fault data is taking longer than expected.  Press OK if you want to continue to wait.  Press Cancel if you want to abort the request to the PLC.";
var SCANNING_MESSAGE = "Getting updated fault data from PLC";
/*--%r End Internationalization Section */

/*--%r Initialization of Constant Variables Section */
var DEFAULT_VALUE = ".";

/*--%r Constants associated with FaultSummary Cell Names */
var TOTAL_FAULTS_CELL_NAME = "total_faults";
var NUM_OF_FAULT_ENTRIES_CELL_NAME = "num_of_fault_entries";
var FAULT_TABLE_CLEARED_TIME_CELL_NAME = "fault_table_cleared_time";
var PLC_DATE_TIME_CELL_NAME = "PLC_date_time";
var ENTRIES_OVERFLOWED_CELL_NAME = "entries_overflowed";

/*--%r Constants associated with FaultTable Row/Cell Names */
var MAIN_FAULT_ROW_NAME = "main_fault_row";
var EXTRA_FAULT_ROW_NAME = "extra_fault_row";
var LOCATION_CELL_NAME = "location";
var FAULT_DESCRIPTION_CELL_NAME = "fault_description";
var FAULT_DATE_TIME_CELL_NAME = "fault_date_time";
var CIRC_NUMBER_CELL_NAME = "circ_number";
var REF_ADDR_CELL_NAME = "ref_addr";
var FAULT_CATEGORY_CELL_NAME = "fault_category";
var FAULT_TYPE_CELL_NAME = "fault_type";

/*--%r Constants associated with the FaultTable Row */
var LOCATION_SEP = "."; /*--%r separates the rack and slot parameters in the location cell */
var FAULT_DATE_TIME_SEP = " / ";

/*--%r Constants associated with FaultTable Extra Fault Cell Names */
var LONG_SHORT_CELL_NAME = "long_short";
var TASK_CELL_NAME = "task";
var GROUP_CELL_NAME = "group";
var ACTION_CELL_NAME = "action";
var ERROR_CODE_CELL_NAME = "error_code";
var FAULT_EXTRA_DATA_CELL_NAME = "fault_extra_data";
var IO_BUS_CELL_NAME = "io_bus";
var BUS_CELL_NAME = "bus";
var POINT_CELL_NAME = "point";
var FAULT_CATEGORY_NUMBER_CELL_NAME = "fault_category_number";
var FAULT_TYPE_NUMBER_CELL_NAME = "fault_type_number";
var EXTRA_FAULT_DATA_SEP = " ";

/*--%r Constants associated with ExtraFaultControl Object */
var BYTE = 0;
var WORD = 1;
var ASCII = 2;
var EXTRA_FAULT_COOKIE_SEP = ":";
var EXTRA_FAULT_COOKIE_NAME = "extra_fault";
var EXTRA_FAULT_COOKIE_LENGTH = 2;

/*--%r Constants associated with the all_faults_string */
var ALL_FAULTS_SEP = "<"; /*--%r separator between major components in the all_faults_string */
var HEADER_FAULT_SEP = ">"; /*--%r separator between components within the Header and Fault 
                                   sections of the all_faults_string */
var MIN_HEADER_ELEMENTS = 3; /*--%r the minimum number of elements within the Header section consisting
                                    total_faults, number_of_fault_entries and fault_table_cleared_time */
var MIN_PLC_FAULT_TABLE_ROW_ELEMENTS = 10;
var MIN_IO_FAULT_TABLE_ROW_ELEMENTS = 16;

/*--%r Indexes in the following sections are derived from the allFlts function tag as described
 *     in the CPU374 Web Server to Web Page Interface Design Document */
/*--%r Index Constants associated with the all_faults_string header arrays */
var HEADER_INDEX = 0;
var TOTAL_FAULTS_INDEX = 0;
var NUM_OF_FAULT_ENTRIES_INDEX = 1;
var FAULT_TABLE_CLEARED_TIME_INDEX = 2;

/*--%r Index Constants associated with the all_faults_string fault PLC fault row arrays */
var PLC_LOCATION_INDEX = 0;
var PLC_FAULT_DESCRIPTION_INDEX = 1;
var PLC_FAULT_DATE_INDEX = 2;
var PLC_FAULT_TIME_INDEX = 3;
var PLC_LONG_SHORT_INDEX = 4;
var PLC_TASK_INDEX = 5;
var PLC_GROUP_INDEX = 6;
var PLC_ACTION_INDEX = 7;
var PLC_ERROR_CODE_INDEX = 8;
var PLC_FAULT_EXTRA_DATA_INDEX = 9;

/*--%r Index Constants associated with the all_faults_string fault I/O fault row arrays */
var IO_LOCATION_INDEX = 0;
var IO_CIRC_NUMBER_INDEX = 1;
var IO_REF_ADDR_INDEX = 2;
var IO_FAULT_CATEGORY_INDEX = 3;
var IO_FAULT_TYPE_INDEX = 4;
var IO_FAULT_DATE_INDEX = 5;
var IO_FAULT_TIME_INDEX = 6;
var IO_LONG_SHORT_INDEX = 7;
var IO_IO_BUS_INDEX = 8;
var IO_BUS_INDEX = 9;
var IO_POINT_INDEX = 10;
var IO_GROUP_INDEX = 11;
var IO_ACTION_INDEX = 12;
var IO_FAULT_CATEGORY_NUMBER_INDEX = 13;
var IO_FAULT_TYPE_NUMBER_INDEX = 14;
var IO_FAULT_EXTRA_DATA_INDEX = 15;

/*--%r Index Constants associated with the get_all_faults function */
var DATE_INDEX = 0;
var TIME_INDEX = 1;

/*--%r Index Constants associated with the extra fault cookie data function */
var SHOW_ALL_INDEX = 0;
var FORMAT_INDEX = 1;

/*--%r Constants associated with ASCII character display and limits */
var MIN_ASCII_CHAR_VALUE = 32;
var MAX_ASCII_CHAR_VALUE = 127;
var ASCII_SPACE_CHAR_VALUE = 32;

/*--%r Constants associated with Error Code limits */
var MAX_ERROR_CODE_VALUE = 32768;

/*--%r ****** START OF IMPORTANT NOTICE *************************/
/*--%r
 * Avoid changing the values assigned below because the values
 * are hard coded into the CASE structure used in the associated 
 * state machine functions (refresh).  
 * This hard coding was required because NETSCAPE does not support 
 * using variables as CASE statement qualifiers.  If a new state 
 * is required, use a value that is not already assigned.
 */ 
/*--%r Refresh states */
var REFRESH_START = 0; /*--%r initialization of the refresh function and
                              request new PLC fault data through the scanFaultWindow */
var REFRESH_SCANFAULTWINDOW_OPENING = 1; /*--%r waiting for scanWindow to fully load. */
var REFRESH_DONE = 2; /*--%r terminal state indicating the refresh function is complete.*/
var REFRESH_IDLE = 3; /*--%r does nothing;  this state traps threads that
                            attempt to execute the refresh function after one refresh
                            process is in progress. */
/*--%r ****** END OF IMPORTANT NOTICE ****************************/

/*--%r Constants associated with the scanFaultWindow */
var SCANFAULTWINDOW_DEFAULT_NAME = "scanFaultWindow";

/*--%r Global Variable declarations */
var fault; /*--%r variable for the fault object */
var default_all_faults_string; /*--r contains the default settings for the fault table.
                                     Note: this is initialized in the init function by
                                     calling the getAllFaults method on the table object */ 
var refresh_state = REFRESH_DONE; /*--%r maintains the state of the refresh state machine */
var scanFaultWindow_name = SCANFAULTWINDOW_DEFAULT_NAME;
var scan_cmplt = false; /*--%r global variable set to true by scanFaultWindow after it opens */
var start_time = 0; /*--%r holds the system time in milliseconds when a scan starts */
var elapsed_time = 0; /*--%r indicates time in milliseconds since the scan started */


/*--%r Function Declaration/Implementation Section */

/*--%r Utility functions */

/*--%r***************************************************************************
* Function    : getExtraFaultDataFormat
*
* Description : This function converts an fault extra data value from a byte format
*               to either BYTE, WORD or ASCII format.
*
* Inputs      : format - the format to use when converting the value.
*               value - the value in BYTE format
*
* Outputs     : returns a string based on the value and the format.
*
* Modified
* Global Data  
* & Objects   : None.
*
* Accessed
* Global Data  
* & Objects   : browser_type - if the browser is Netscape and the format is ASCII,
*               the function returns an string indicating it cannot convert to ASCII
*               when the browser type is Netscape.  This is because Netscape does 
*               not support ASCII conversion routines.
*
*
*************************************************************************************/ 
function getExtraFaultDataFormat(format, value)
{
    var return_value = ""; /*--%r string to hold intermediate formatting results and
                            *     to return the final value */
    var i; /*--r index variable used by FOR loops */
    var temp; /*--%r used a temporary storage location during formatting */
    var value_parse_array; /*--%r an array to hold the extra fault data values */
    /*--%r
     * SELECT from one of the following cases depending on the format value
     *     CASE format is BYTE
     *         return the value without formatting; it is already in BYTE format
     *     ENDCASE format is BYTE
     *     CASE format is WORD
     *         split the value into an array of byte values
     *         IF the length of the array is greater than 1 (then it is valid to format)
     *             FOR every two values in the array
     *                 IF this is not the last value and the length is not odd
     *                     make a string with the second value and then the first value
     *                     concantenate this string to the return_value string
     *                 ELSE this is the last value and the length is odd
     *                     make a string with only the first value
     *                     contantenate this string to the return_value string
     *                 ENDIF this is not the last value and the length is not odd
     *             ENDFOR every two values in the array
     *        ELSE the value is not valid to format
     *             return the value without formatting
     *        ENDIF the length of the array is greater than 1 ... 
     *    ENDCASE format is WORD
     */
    switch(format)
    {
        case 0 /*--%r BYTE */:
            return value; /*--%r the value is stored in byte format;
                           *     so just use the value directly */
            break;
        case 1 /*--%r WORD */:
            value_parse_array = value.split(EXTRA_FAULT_DATA_SEP);
            if (value_parse_array.length > 1)
            { 
                for (i = 0; i < value_parse_array.length; i++)
                {
                    if (i != (value_parse_array.length - 1))
                    {
                        return_value += value_parse_array[i+1] + value_parse_array[i] + EXTRA_FAULT_DATA_SEP;
                    }
                    else
                    {
                        return_value += value_parse_array[i] + EXTRA_FAULT_DATA_SEP;
                    }            
                    i++
                }
            }
            else
            {
                return_value = value
            }        
            return return_value;
            break;
  /*--%r
     *     CASE format is ASCII
     *         split the value into an array of bytes
     *         FOR each byte of the array
     *             get the numeric value of the byte
     *             IF able to get a numeric value (it is a number)
     *                 IF the numeric value is a value ASCII character
     *                      convert number to ASCII character and concantenate to return string
     *                 ELSE convert 32 (SPACE) to ASCII character and concantenate to return string
     *             ELSE unable to get a numeric value (it is not a number)
     *                 set the return value equal to the input value (don't try to format)
     *                 break from the FOR loop
     *             ENDIF able to get a numeric value (it is a number) 
     *         ENDFOR each byte of the array
     *     ENDCASE format is ASCII            
     * ENDSELECT from one of the following cases depending on the format value
     */                           
        case 2 /*--%r ASCII */:
            value_parse_array = value.split(EXTRA_FAULT_DATA_SEP);
            for (i = 0; i < value_parse_array.length; i++)
            {
                temp = parseInt(value_parse_array[i],16);
                if (!isNaN(temp))
                {
                    if(temp>MIN_ASCII_CHAR_VALUE && temp<MAX_ASCII_CHAR_VALUE)
                    {
                       return_value += convertToASCII(temp);  	

                    }
                    else
                    {
                       return_value += convertToASCII(ASCII_SPACE_CHAR_VALUE);  	                        
                    } 
                    
                }
                else
                {
                    return_value = value;
                    break;
                }    
            }    
		
            return return_value;
            break;
        default:
            alert(APPLICATION_ERROR);
    }
    return DEFAULT_VALUE;
}      


/*--%r***************************************************************************
* Function    : getTableRow
*
* Description : This function determines the index of the row where the user's
*               mouse either passed over or out of.  It does this by using the id
*               of the element that caused the event, determining if this element
*               is in the row, getting the name of the row element associated
*               with the element and extracting the number at the end of the row
*               name to get the row index.
*
* Inputs      : id - the id of the element that was either passed over or out of by
*               the user's mouse.
*
* Outputs     : index - returns the index of the row where the mouse passed over or
*               out of or if the index cannot be found it returns ERROR.
*
* Modified
* Global Data  
* & Objects   : None.
*
* Accessed
* Global Data  
* & Objects   : TYPE - the function must look for different elements depending
*               on whether this is a PLC or I/O Fault Table.
*
*
*************************************************************************************/ 
 function getTableRow(id)
{
    var name, index;
    /*--%r
     * create a string object from the object passed over or out of
     * IF this is a PLC fault table
     *     set up a matching string based on Location, Description and Time
     * ELSE this is an I/O fault table
     *     set up a matching string based on Location, Circuit Number, Ref Addr,
     *             Category, fault type and time
     * ENDIF this is a PLC fault table
     * get the name that matches the object's id name
     * IF the name is found
     *     set up a matching string to find the number at the end of the name string
     *     IF the number is found
     *         set the index value equal to the number
     *     ELSE the number is not found
     *         set the index equal to ERROR
     *     ENDIF the number is found
     * ELSE the name is not found
     *    set the index equal to ERROR
     * ENDIF the name is found
     * return the index
     */
    var parentname=new String(id);
    if (TYPE == "PLC")
    {
        eval('var re=/' + LOCATION_CELL_NAME + '|' +  FAULT_DESCRIPTION_CELL_NAME + '|' + FAULT_DATE_TIME_CELL_NAME + '/'); ///Location|Description|Time/;
    }
    else
    {    
	    eval('var re=/' + LOCATION_CELL_NAME + '|' + CIRC_NUMBER_CELL_NAME + '|' + REF_ADDR_CELL_NAME + '|' + FAULT_CATEGORY_CELL_NAME + '|' + FAULT_TYPE_CELL_NAME + '|' + FAULT_DATE_TIME_CELL_NAME + '/'); ///Location|CircNo|RefAddr|Category|FltType|Time/;
	}
	name = parentname.match(re);
	if ( name ) 
	{
		re=/\d{1,}/;  /*--%r this is the pattern matching syntax for finding 1 or more digits in the string */
		index=parentname.match(re);
		if (!index) 
		{
			index = ERROR;
		}
	}
	else 
	{
		index= ERROR;
	}
	return(index);
}
 
/*--%r***************************************************************************
* Function    : refreshErrorHandler
*
* Description : This function is called if the scanFaultWindow gets deleted during
*               the scanning operation.  It sets the refresh_state to REFRESH_DONE 
*               so that the refresh process can complete.
*
* Inputs      : msg - this is the error message from the browser for the particular error.
*               url - this is the URL of the page that caused the error
*               line - this is the line number where the error occurred on the web page
*
* Outputs     : This function returns true indicating browser error handler
*               should not be invoked
*
* Modified
* Global Data  
* & Objects   : refresh_state
*
*
****************************************************************************/
function refreshErrorHandler(msg, url, line)
{
    /*--%r
     * an error has occurred trying to access the scanFaultWindow 
     *    (the user may have deleted it)
     * indicate in the browser status line that the PLC data could not be obtained
     *    because the scanFaultWindow was closed.
     * set the refresh_state to REFRESH_DONE so the scan routine completes
     * set the error handler to the default handler
     * return true so that the browser error handler doesn't report error
     */
    window.defaultStatus = SCAN_FAULT_WINDOW_DELETED_MESSAGE;
    refresh_state = REFRESH_DONE;
    self.onerror = defaultErrorHandler;
    return true;
     
}


/*--%r Main Process functions */

/*--%r***************************************************************************
* Function    : init
*
* Description : This function initializes the web page including
*               checking the browser type and version, checking
*               if cookies are supported, creating the fault object,
*               populating the fault object with fault data, getting
*               the extra fault control settings from a cookie and
*               displaying the fault table.
*               In RAD4, this function will set the global variables
*               sep_type and date_type from a cookie.  
*              
* Inputs      : None
*
* Outputs     : None
*
* Modified
* Global Data  
* & Objects   : fault - creates and sets properties.
*               browser_type - reads from browser and stores in variable
*               browser_version - reads from browser and stores in variable
*               sep_type - reads from sepDate cookie and sets (RAD4)
*               date_type - reads from sepDate cookie and sets (RAD4)
*               cookies_enabled - reads from browser and sets
*               browser_refresh - set true if the browser supports dynamic
*                   updates of the user display.
* Global Data
* Accesses:     None.
*
****************************************************************************/
function init()
{
    var test_cookie; /*--%r used to test whether the browser supports cookies */
    /*--%r
     * set status to OK
     * initialize the browser status line
     * call common initialization function that initializes the default
     *          error handler, updates the PC date and time and checks the 
     *          browser type and version (Note: call init_common)
     */
    var status = OK;
    window.defaultStatus = INIT_MESSAGE;
    initCommon();
         
    /*--%r
     * get browser cookie capability (supported/not supported)
     * IF cookies are not supported 
     *     put up dialog indicating the web page relies on using cookies
     *             to save the extra fault control settings
     * ELSE cookies are supported
     *     global variable cookies_enabled
     * ENDIF cookies are not supported
     */
    if (cookieTest() == ERROR)
    {
        alert(COOKIE_WARNING_MESSAGE);
    }
    else
    {
        cookies_enabled = true;
    }    
        
    /*--%r
     * create fault object
     * save the default fault properties in a string 
     * populate the fault object with the data in the all_faults_string from the PLC
     * IF there is an error populating the fault object with the all_faults_string
     *     restore the default fault properties
     *     indicate there was an error getting updated PLC fault data in the browser
     *             status line.
     *     set status to ERROR
     * ENDIF there is an error populating the fault object with the all_faults_string
     * get the extra fault control settings from cookie and store in fault object
     *         (Note: no need to check for error since the values are already defaulted)
     * FOR each row in the fault table
     *     set the show_fault property of the extra Fault Row to the same state as the 
     *             show_all property in the extra fault control object
     *     set the fault extra data format property to equal the format property in the extra
     *             fault control object
     * ENDFOR each row in the fault table
     * IF the browser type is Netscape
     *     register the resize handler when the window size changes
     *        so that the window is displayed correctly; Note this is
     *        not required for IE because IE dynamically updates the GUI
     *        without a refresh.  Netscape is not able to correctly update
     *        the GUI dynamically and requires a refresh.  Therefore, when using
     *        Netscape, the resize handler refreshes
     *        the screen so the GUI looks correct with the new window size.
     * ENDIF the browser type is Netscape
     * display the fault table
     * IF there is not an initialization error
     *     show PLC status in browser status line
     * ENDIF there is not an initialization error
     */
    fault = new Fault(TYPE, NUM_OF_ROWS);
    default_all_faults_string = fault.getAllFaults();
    /*--%r
    Initialize PLC_Date and PLC_Name from this documents by using the local varaible PLC_date and PLC_name
    There is PLC_name here and one in scanFaultWindow that are assigned to PLC_NAME. Same thing with PLC_Date
    --*/
    PLC_Date = PLC_date;
    PLC_Name = PLC_name;
    if (fault.setAllFaults(all_faults_string) == ERROR)
    {
        window.defaultStatus = BAD_PLC_FAULT_DATA_MESSAGE;
        status = ERROR;
    }
    fault.extraFaultControl.setFromCookie();
    var show_fault = fault.extraFaultControl.getShowAll();
    var format = fault.extraFaultControl.getFormat();
    for (var i = 0; i < fault.faultTable.num_of_rows; i++)
    {
        fault.faultTable.extraFaultRow[i].show_fault = show_fault;
        fault.faultTable.extraFaultRow[i].fault_extra_data.setFormat(format);
    }    
    if (browser_type == NETSCAPE)
    {
        window.onresize = resizeWindow;
    }
    displayFaultTable();
    if (status == OK)
    {
    /*--%r WORK_TODO:  must update this code to use the actual status from the PLC rather than hard coded values */
//        window.defaultStatus = "PLC Mode:  Stop I/O Enabled      PLC Sweep Time:  2.5 msec    Program Name:  TEST1     PLC Date/Time:  "+ PC_date;
        window.defaultStatus = "Done";
    }
    fault.refresh();
}
/*--%r***************************************************************************
* Function    : refresh
*
* Description : This function updates the fault data in the fault table with
*               fresh data from the PLC.  This function is set-up as a state
*               machine since it must periodically call itself while it waits
*               for the scanFaultWindow to load.  This approach provides 
*               bandwidth for the scanFaultWindow process so that the load operation
*               completes. If the browser does not support dynamic refresh,
*               the function saves the extra fault control settings and then
*               reloads the page so the display can be updated.
*
* States      : REFRESH_START - initialization of the refresh function and
*                   request new PLC fault data through the scanFaultWindow
*               REFRESH_SCANFAULTWINDOW_OPENING - waiting for scanWindow to fully 
*                   load.
*               REFRESH_IDLE - does nothing;  this state traps threads that
*                   attempt to execute the refresh function after one refresh
*                   process is in progress.
*               REFRESH_DONE - terminal state indicating the refresh function
*                   is complete. 
*
* Inputs      : None
*
* Outputs     : None
*
* Modified
* Global Data  
* & Objects   : fault - sets properties.
*               scanFaultWindow - sets properties.
*               refresh_state - controls state of refresh state machine
*               the error handler is changed to the refreshErrorHandler
*
* Global Data
* Accesses:     browser_type
*
****************************************************************************/
function refresh()
{
    var temp; /*--%r temporary variable to hold intermedate scanFormatWindow_name number */
    /*--%r 
     * Select from the following Cases which represent refresh states 
     */
    switch(refresh_state)
    {
    /*--%r 
     * CASE refresh_state is set to REFRESH_START
     *     Set the refresh_state to REFRESH_IDLE to prevent re-entrance
     *     IF the browser supports dynamic refresh
     *         register the refresh error handler in case the scanFaultWindow is deleted
     *                 causing an error in accessing the window.
     *         open a scanFaultWindow using a random window name to avoid
     *                 conflicting with another browser instance
     *         create the scanFaultForm element and the hidden form element named "type" in 
     *                 the scanFaultWindow; set type to equal the type of fault table
     *         write the fault table type (PLC or I/O) to the value of the "type"
     *             hidden form element
     *         set the scan_cmplt flag to false
     *         set the start_time global variable to the current PC time
     *         set the elapsed_time global variable to 0
     *         put message in browser status line indicating we are getting PLC fault data
     *         submit the scanFaultForm element to the PLC web server
     *         set the refresh_state equal to REFRESH_SCANFAULTWINDOW_OPENING
     *     ELSE the browser does not support dynamic refresh
     *         save the extra fault control state (Show All, format radio buttons)
     *                  to a cookie
     *         set the refresh_state equal to REFRESH_DONE
     *         reload the page
     *     ENDIF the browser supports dynamic refresh
     * ENDCASE refresh_state is set to REFRESH_START         
     */
        case 0 /*--%r REFRESH_START*/:
            refresh_state = REFRESH_IDLE; /*--%r protects against reentrancy issues */
            if (browser_refresh)
            {
                self.onerror = refreshErrorHandler;
                temp = Math.round(1000000 * Math.random());  
                scanFaultWindow_name = SCANFAULTWINDOW_DEFAULT_NAME + temp;
                scanFaultWindow = window.open("",scanFaultWindow_name, "height=1,width=1,top=1000,left=1000");
                window.focus(); /*--%r keep focus on main window */
                scanFaultWindow.document.write("<html><head></head><body>");
                scanFaultWindow.document.write("<form method='GET' action = 'scanFaultWindow.htm' name='scanFaultForm' >");
                eval("scanFaultWindow.document.write(\"<input type ='hidden' name = 'type' value = '" + TYPE + "'>\");");
                scanFaultWindow.document.write("</form>");
                scanFaultWindow.document.write("</body></html>");
                scanFaultWindow.document.close();
                scan_cmplt = false;
                date_obj = new Date();
                start_time = date_obj.getTime();
                elapsed_time = 0;
                window.defaultStatus = SCANNING_MESSAGE;
                scanFaultWindow.document.scanFaultForm.submit();
                refresh_state = REFRESH_SCANFAULTWINDOW_OPENING;
            }
            else
            {
                fault.extraFaultControl.storeToCookie();
                refresh_state = REFRESH_DONE;
                location.reload();
            }    
            break;
    /*--%r 
     * CASE refresh_state is set to REFRESH_SCANFAULTWINDOW_OPENING
     *     set the refresh_status to REFRESH_IDLE to prevent re-entrancy
     *     IF the scan_cmplt flag is true (scanFaultWindow has loaded)
     *         set the fault object properties to default to clear out old data
     *         populate the fault object with the all_faults_string from the
     *             the scanFaultWindow
     *         IF there is an error populating the fault object with the all_faults_string
     *             set the fault object properties to default
     *             indicate there was an error getting updated PLC fault data in the browser
     *                     status line.
     *         ENDIF there is an error populating the fault object with the all_faults_string
     *         close the scanFaultWindow
     *         refresh the fault object with the new fault data
     *         update the PC time in the header and in browser status line
     *         set the error handler to the default error handler
     *         set the refresh_status to REFRESH_DONE
     *     ELSE the scanFaultWindow is still loading
     *         update elapsed_time based on reading new PC time
     *         IF elapsed_time is greater than the SCAN_TIMEOUT
     *             put up dialog asking user if they want to continue waiting for the updated
     *                     PLC data
     *             IF the user wants to continue waiting for PLC data
     *                 reset the elapsed time to 0 and reinitialize the start_time
     *                 set the refresh_status to REFRESH_SCANFAULTWINDOW_OPENING 
     *             ELSE the user wants to cancel the operation
     *                 Set the browser status line to indicate PLC did not respond with
     *                         data within SCAN_TIMEOUT period.
     *                 close the scanFaultWindow
     *                 set the error handler to the default error handler
     *                 set refresh_state to REFRESH_DONE    
     *             ENDIF the user wants to continue waiting for PLC data
     *         ELSE elapsed_time is less than the SCAN_TIMEOUT
     *             set the refresh_status to REFRESH_SCANFAULTWINDOW_OPENING
     *         ENDIF the elapsed_time is greater than the scan_timeout
     *     ENDIF the scan_cmplt flag is true (scanFaultWindow has loaded)
     * ENDCASE refresh_state is set to REFRESH_SCANFAULTWINDOW_OPENING
     */
        case 1 /*--%r REFRESH_SCANFAULTWINDOW_OPENING */:
            refresh_state = REFRESH_IDLE; /*--%r protects against reentrancy issues */
            if (scan_cmplt)
            {
                PLC_Date = scanFaultWindow.PLC_date;
                PLC_Name = scanFaultWindow.PLC_name;
                document.all(PLC_NAME_ID).innerHTML = "<b>" + PLC_Name + "</b>";
                document.all(PC_DATE_ID).innerHTML = "<b>" + PLC_Date + "</b>";

                fault.setAllFaults(default_all_faults_string);
                if (fault.setAllFaults(scanFaultWindow.all_faults_string) == ERROR)
                {
                    window.defaultStatus = BAD_PLC_FAULT_DATA_MESSAGE;
                }
                else
                {
                /*--%r WORK_TODO: must update with real PLC data rather than being hard coded */
//                    window.defaultStatus = "PLC Mode:  Stop I/O Enabled      PLC Sweep Time:  2.5 msec    Program Name:  TEST1     PLC Date/Time:  "+ PC_date;
                    window.defaultStatus = "Done";
                }
                scanFaultWindow.close();
                fault.refresh();
                self.onerror = defaultErrorHandler;
                refresh_state = REFRESH_DONE;
            }
            else
            {
                date_obj = new Date();
                elapsed_time = date_obj.getTime();
                elapsed_time =  elapsed_time - start_time;
                if (elapsed_time >= SCAN_TIMEOUT)
                {
                    if (confirm(SCAN_TIMEOUT_MESSAGE))
                    {
                        date_obj = new Date();
                        start_time = date_obj.getTime();
                        elapsed_time = 0;
                        refresh_state = REFRESH_SCANFAULTWINDOW_OPENING;
                    }
                    else
                    {
                        window.defaultStatus = PLC_TIMEOUT;
                        scanFaultWindow.close();
                        self.onerror = defaultErrorHandler;
                        refresh_state = REFRESH_DONE;
                     }
                }
                else
                {
                    refresh_state = REFRESH_SCANFAULTWINDOW_OPENING;
                }
            }        
            break;
              
    /*--%r 
     * CASE refresh_state is set to REFRESH_DONE
     *     set refresh_state to REFRESH_START so that the next time
     *             the function is called it begins in the proper first
     *             state.
     * ENDCASE refresh_state is set to "refresh_done"
     */
        case 2 /*--%r REFRESH_DONE */:
            refresh_state = REFRESH_START;
            break;
    /*--%r 
     * CASE refresh_state is set to REFRESH_IDLE
     *     do nothing; this state is entered if the browser allows
     *         a user's input on the refresh button to start another 
     *         thread through the refresh code before the current
     *         refresh process is complete.  In this case, we don't
     *         re-schedule refresh but just exit from the function
     *         without doing anything.    
     * ENDCASE refresh_state is set to REFRESH_IDLE
     */
        case 3 /*--%r REFRESH_IDLE */:
            break;
    /*--%r
     * End Select from the following Cases which represent refresh states
     */
        default:
            alert(APPLICATION_ERROR);
    }    
    /*--%r  
     * IF refresh_state does not equal REFRESH_DONE
     *     IF refresh_state does not equal REFRESH_IDLE
     *         set up timer to call refresh() again in 1 millisecond
     *     ENDIF refresh_state does not equal refresh_idle
     * ENDIF refresh_state does not equal refresh_done
     */
    if (refresh_state != REFRESH_DONE)
    {
        if (refresh_state != REFRESH_IDLE)
        {
            setTimeout("refresh();", 1);
        }
    }    
}

/*--%r***************************************************************************
* Function    : shutdown
*
* Description : This function is called by the unload event.  It's primary
*               purpose is to save the state of the Show All checkbox and 
*               extra data format radio buttons so they are re-stored the 
*               next time the page is opened.
*
* Inputs      : None
*
* Outputs     : None
*
* Modified
* Global Data  
* & Objects   : extraFaultControl.storeToCookie
*
* Global Data
* Accesses:     browser_type
*
****************************************************************************/
function shutdown()
{
    /*--%r 
     * IF the browser type is not NETSCAPE
     *     store the Show All and extra fault data radio button states to a 
     *             cookie; (Note: we can't store cookies when shutting
     *             down in NETSCAPE because it causes a browser error; instead
     *             the refresh function saves these before reloading the page)
     * ENDIF the browser type is not NETSCAPE
     */
    if (browser_type != NETSCAPE)
    {
        fault.extraFaultControl.storeToCookie();
    }        
}


/*--%r***************************************************************************
* Function    : displayFaultTable
*
* Description : This function creates the user display for the fault table.  
*               It calls the createHeader function which creates the top of the 
*               page (GEF logo, links to other pages, PLC name, PC time etc).  
*               It then calls the fault.createHTML() method which displays 
*               the fault table.
*  
*
* Inputs      : None
*
* Outputs     : None
*
* Modified
* Global Data  
* & Objects   : fault.createHTML
*               createHeader
*
* Global Data
* Accesses:     browser_refresh
*
****************************************************************************/
function displayFaultTable()
{
    /*--%r 
     * IF the browser does not support dynamic refresh
     *     IF the browser does not support cookies
     *         set the show_all property in the fault object and the show_fault
     *                 property for each extra fault row so that when 
     *                 the page is displayed the extra fault data is 
     *                 displayed (Note: the extra fault data must always be 
     *                 displayed because the user has no way to specify 
     *                 whether to show or hide it).
     *     ENDIF the browser does not support cookies
     * ENDIF the browser does not support dynamic refresh
     * create the HTML output for the styles
     * create the HTML output for the header of the page
     * create the HTML output for the fault object
     */
    if (!browser_refresh)
    {
        if (!cookies_enabled)
        {
            fault.extraFaultControl.setShowAll(true);
            for (var i = 0; i < fault.faultTable.num_of_rows; i++)
            {
                fault.faultTable.extraFaultRow[i].show_fault = true;
            }    
        }
    }
    createStyles();
    createHeader(TYPE);
    /*--%r#if debug */
    log_event("starting to create fault html");
    /*--%r#endif */
    fault.createHTML();
    /*--%r#if debug */
    log_event("before document close");
    /*--%r#endif */
    document.close();
    /*--%r#if debug */
    log_event("after document close");        
    /*--%r#endif */
}

/*--%r***************************************************************************
* Function    : createHeader
*
* Description : this function creates the HTML output for the header  
*
* Inputs      : type - determines whether a PLC fault table or I/O fault table
*                   header is created
*
* Outputs     : None 
*
* Modified
* Global Data : None
*
* Global Data
* Accessed:   : Global constants & variables accessed:
*                   PLC_FAULT_TABLE_TITLE - the title shown at the top of the page
*                       for the PLC fault table.
*                   IO_FAULT_TABLE_TITLE - the title shown at the top of the page
*                       for the I/O fault table.
*                   PLC_NAME - the PLC Name title shown at the top of the page
*                   PLC_NAME_TEXTBOX - the name of the textbox element that 
*                      contains the PLC name.
*                   PLC_TIME - PC time label
*                   PC_date - a string containing the PC's date and time.
*                   PC_DATE_ID - the ID of the HTML element that shows the PC date & time;
*                       this is used to update the PC date and time on each refresh.
*                   browser_type - determines how to display depending on the type of browser
*
****************************************************************************/
function createHeader(type)
{
    /*--%r
     * create header HTML output 
     */
    with (document)
    {
        write('<table border="0" cellpadding="0" cellspacing="0" >');
        write('<tr>');
        write('<td ><a href="http://www.gefanuc.com"><img border="0" src="Clrgef25.gif" align="left"></a></td>');
        if (type == "PLC")
        {
            write('<td nowrap class="header1"><b>&nbsp;' + PLC_FAULT_TABLE_TITLE + '</b></td>');
        }
        else
        {
            write('<td nowrap class="header1"><b>&nbsp;' + IO_FAULT_TABLE_TITLE + '</b></td>');
        }

       write('<td width="10%"></td>');  
       write('<td nowrap class="header2" align="right"><p align="right"><b>&nbsp;' + PLC_NAME + '&nbsp;&nbsp;</b></td>'); 
       write('<td nowrap class="header2" align="left" id =\"'+ PLC_NAME_ID +'\"><b>' + PLC_Name + '</b></td>');
 /*--      if (browser_type == IE)
       {
           write('<input type="text" name=\"' + PLC_NAME_TEXTBOX + '\" size="18" style="font-weight: bold; position: relative; left: 0; top: 0; font-size: 12pt" value="' + PLC_NAME + '" onFocus = "this.blur();" onSubmit = "return false;">');
       }
       else
       {
           write('<input type="text" name=\"' + PLC_NAME_TEXTBOX + '\" size="12" style="font-weight: bold; position: relative; left: 0; top: 0; font-size: 10pt" value="" onFocus = "this.blur();" onSubmit = "return false;">');
       }
--*/

       write('<td width="3%"></td>');
       write('<td nowrap class="header2" align="right"><p align="right"><b>&nbsp;' + PLC_TIME + '&nbsp;&nbsp;</b></td>'); 
       write('<td nowrap class="header2" align="left" id =\"'+ PC_DATE_ID +'\"><b>' + PLC_Date + '</b></td>');
       write('</tr>');
       write('</table></font>');
       write('<div align=center>');
       write('<table border="0" cellpadding="0" cellspacing="0" width="95%">');
       write('<tr>');
/*--%r WORK_TODO: Add when RAD 4 support added
       write('<td width="25%" nowrap align="center"><font size="2">&nbsp;<a href="index.htm">' + STATUS_LINK + '</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</font></td>');
--*/
       write('<td width="25%" nowrap align="center"><font size="2">&nbsp;&nbsp;&nbsp; <a href="reference_tables.htm">' + REFERENCE_TABLE_LINK + '</a>&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;</font></td>');
       if (type == "PLC")
       {
           write('<td width="25%" nowrap align="center"><font face=verdana size=2><input type="submit" class = "button" value="' + PLC_FAULT_TABLE_BUTTON + '" style="color: #0000FF" onClick="if(init_complete){refresh();} return false;"></font></td>');
           write('<td width="25%" nowrap align="center">');
           write('<p align="center"><font size="2">&nbsp;&nbsp;&nbsp; <a href="io_fault_tables.htm">' + IO_FAULT_TABLE_LINK + '</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</font></td>');
       }
       else
       {
           write('<td width="25%" nowrap align="center">');
           write('<p align="center"><font size="2">&nbsp;&nbsp;&nbsp; <a href="plc_fault_tables.htm">' + PLC_FAULT_TABLE_LINK + '</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</font></td>');
           write('<td width="25%" nowrap align="center"><font face=verdana size=2><input type="submit" class = "button" value="' + IO_FAULT_TABLE_BUTTON + '" style="color: #0000FF" onClick="if(init_complete){refresh();} return false;"></font></td>');
       }
       write('</tr></table></div>');
    }        
}

/*--%r***************************************************************************
* Function    : createStyles
*
* Description : this function creates the various HTML styles used by the components
*               of the web page.
*
* Inputs      : None
*
* Outputs     : None 
*
* Modified
* Global Data : None
*
* Global Data
* Accessed:     None   
*
****************************************************************************/
function createStyles()
{
    /*--%r
     * write the styles that will be used display the various elements on the screen
     */
        with (document)
    {
        write('<STYLE>');
        write('A {color:blue;font-weight:bold;font-family:verdana;text-decoration:none;}');
        write('A:hover {color:red;text-decoration:underline;}');
        write('A:hover.fault {text-align:left;color:black;font-size:8pt;font-weight:medium;font-family:verdana;text-decoration:none;background-color:lightblue;}');
        write('A.fault {text-align:left;color:black;font-size:8pt;font-weight:medium;font-family:verdana;text-decoration:none;}');
        write('INPUT.button {color:blue;font-weight:bold;font-family:verdana;text-decoration:none;}');
        write('TD.header1 {text-align:left;color:black;font-size:13pt;font-weight:medium;font-family:verdana;}');
        write('TD.header2 {text-align:left;color:black;font-size:10pt;font-weight:medium;font-family:verdana;}');
        write('TD.extrainfoheader {background-color: #F0F0F0;text-align: center;text-color: black;font-size: 8pt;font-family: verdana;font-weight: medium;}');
        if (browser_type == NETSCAPE)
        {
            write('TD.extrainfo {background-color: white;text-align: center;color: darkred;font-size: 8pt;font-family: verdana;font-weight: medium;}');
            write('TD.tableheader {text-align:center;background-color:lightgrey;color: black;font-family: verdana;font-weight: bold;font-size: 9pt;}');
            write('TD.tableheader2 {text-align:center;background-color:lightgrey;color: black;font-family: verdana;font-weight: bold;font-size: 9pt;}');
            write('TD.faultStyle1 {text-align:left;color:black;font-size:8pt;font-weight:medium;font-family:verdana;}');
            write('TD.faultStyle2 {text-align:center;color:black;font-size:8pt;font-weight:medium;font-family:verdana;}');
        }
        else
        {
            write('TD.extrainfo {background-color: white;text-align: center;color: darkred;font-size: 7pt;font-family: verdana;font-weight: medium;}');
            write('TD.tableheader {text-align:center;background-color:lightgrey;color: black;font-family: verdana;font-weight: bold;font-size: 8pt;}');
            write('TD.tableheader2 {text-align:center;background-color:lightgrey;color: black;font-family: verdana;font-weight: bold;font-size: 8pt;}');
            write('TD.faultStyle1 {text-align:left;color:black;font-size:8pt;font-weight:medium;font-family:verdana;}');
            write('TD.faultStyle2 {text-align:center;color:black;font-size:8pt;font-weight:medium;font-family:verdana;}');
        }        
        write('TD.PLCTitle {text-align:center;background-color:darkblue;color: white;font-family: Arial;font-weight: bold;font-size: 10pt;}');
        write('DIV.clsCollapsed {display:none;}');
        write('DIV.clsExpanded {display:block;}');
        write('</STYLE>');
    }
}


/*--%r Functions associated with Object Methods */

/*--%r**************************************************************************
* Function    : Create_HTML
*
* Description : This method creates the HTML output for the fault object based 
*               on the values contained in the fault object which causes the fault
*               table to be displayed by the browser. 
*
* Associated
*  Method     : Fault.createHTML()
*
* Inputs      : None
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : this.FaultSummary.createHTML()
*               this.FaultTable.createHTML()
*               this.ExtraFaultControl.createHTML()
*
* Modified
* Global Data
* & Objects   : None
*                   
****************************************************************************/
function Create_HTML()
{
    /*--%r
     * create start table HTML output
     * create start row, cell, division HTML output
     * create HTML output for the fault summary table
     * create end division and end cell HTML output
     * create start cell HTML output
     * create HTML output for the extra fault data control elements
     * create end of cell, a blank cell and end or row HTML output
     * create start of row, start of cell span 2 and start of division HTML output
     * create HTML output for the fault table
     * create end of division, end of cell, end of row and end of table HTML output
     */
    with (document)
    {
        write('<TABLE width=95% border=0 align=center cellspacing=0 cellpadding=5>');
        write('<tr><td><div align="center"><center><font face=verdana>');
        /*--%r#if debug */
        log_event("creating fault summary table");
        /*--%r#endif */
        this.faultSummary.createHTML();
        write('</font></center></div></td>');
        write('<td valign="top" align="center">');
        /*--%r#if debug */
        log_event("creating extra fault control");
        /*--%r#endif */
        this.extraFaultControl.createHTML();
        write('</td><td width="15%"></td></tr>');
        write('<tr><td colspan="2"><div>');
        /*--%r#if debug */
        log_event("creating fault table");
        /*--%r#endif */
        this.faultTable.createHTML();
        /*--%r#if debug */
        log_event("before end of big table");
        /*--%r#endif */
        write('</div></td><td></td></tr></table>');
        /*--%r#if debug */
        log_event("after end of big table");
        /*--%r#endif */
    }    
}

/*--%r**************************************************************************
* Function    : Set_all_faults
*
* Description : The purpose of this method is to set all the various fault 
*               object properties by parsing the fault information in the 
*               all_faults_string.  The all_faults_string contains the updated 
*               fault data from the PLC.   
*
* Associated
*  Method     : Fault.setAllFaults()
*
* Inputs      : all_faults_string  contains the latest fault information 
*                   from the PLC.
*               reentrant - indicates whether this function should attempt
*                   to call itself again to re-store the previous values
*                   if an error occurs;  "REENTRANT" means it should
*                   try to re-store the previous values and "NOT_REENTRANT"
*                   means to not re-store the previous values so that the
*                   function does not call itself again.
*
* Outputs     : This function returns OK if the all elements are set 
*               without error.  Otherwise, this method returns ERROR.
*
* Global Data
* & Objects
* Accessed    : None.
*
* Modified
* Global Data
* & Objects   : this.FaultTable.setRow()
*               this.FaultSummary - sets the various elements in the object
*                   
****************************************************************************/
function Set_all_faults(all_faults_string, reentrant)
{
    /*--%r
     * initialize status variable to OK
     * IF reentrant variable is not defined meaning this function is called
     *          by a function other that the Set_all_faults function
     *     set local_reentrant flag to true
     * ELSE
     *     set local_reentrant flag to equal reentrant flag
     * ENDIF reentrant variable is not defined .... 
     * save the current state of the fault object in case there is an error
     * break string into header_string and faultN_string components
     * IF the number of elements is greater than the (maximum fault entries
     *        + 1) (add one for the header element)
     *     set the status to ERROR
     * ELSE the number of elements is less than or equal to ....
     */
    var status = OK;
    var reentrant_flag = "";
    if (!reentrant) /*--%r reentrant set up as a string rather than boolean so we can
                     * check to see if the variable object exists;  otherwise if it does
                     * exist and was a boolean, the check becomes a boolean state check 
                     * rather than an object exist check */
    {
        reentrant_flag = "REENTRANT";
    }
    else
    {
        reentrant_flag = reentrant;
    }                
    var saved_fault_state = this.getAllFaults();
    var all_faults_parse_array = all_faults_string.split(ALL_FAULTS_SEP);
    if (all_faults_parse_array.length > (this.faultTable.num_of_rows + 1))
    {
        status = ERROR;
    }
    else
    {    
    /*--%r 
     *     break header_string into total_faults, number_of_fault_entries
     *         and fault_table_cleared_time
     *     IF the number of elements is less than the expected number of summary
     *             table elements (Note: only check less than so an element
     *             could be added later without breaking this code)
     *         set the status to ERROR
     *     ELSE the number of elements equal or greater than the expected number of summary
     */
        var header_parse_array = all_faults_parse_array[HEADER_INDEX].split(HEADER_FAULT_SEP);
        if (header_parse_array.length < MIN_HEADER_ELEMENTS)
        {
            status = ERROR;
        }
        else
        {     
    /*--%r 
     *         assign header_string elements to corresponding elements in  the 
     *                 faultSummary object.
     *         IF the total_faults minus the num_of_fault_entries is a valid number
     *             assign the faultSummary entries_overflowed property to the total_faults 
     *                     minus the num_of_fault_entries
     *         ELSE the total_faults minus the num_of_fault_entries is a not a number (NaN)
     *             assign the faultSummary entries overflowed property to the default value
     *         ENDIF the total_faults minus the num_of_fault_entries is a valid number
     *         assign the faultSummary PLC_date_time property with PC time (PLC time for RAD5)
     *         IF there is an error setting any of the faultSummary properties
     *             set the status to ERROR
     *         ELSE there is not an error setting any of the faultSummary properties
     *             IF the number of fault entries value does not equal the number of faults
     *                 set the status to ERROR
     *             ELSE the number of fault entries value does equal the number of faults
     */
            with (this.faultSummary)
            {
                status += total_faults.cell.setValue(header_parse_array[TOTAL_FAULTS_INDEX]);
                status += num_of_fault_entries.cell.setValue(header_parse_array[NUM_OF_FAULT_ENTRIES_INDEX]);
                status += fault_table_cleared_time.cell.setValue(header_parse_array[FAULT_TABLE_CLEARED_TIME_INDEX]);
                var temp = parseInt(total_faults.cell.value) - parseInt(num_of_fault_entries.cell.value)
                if (!isNaN(temp))
                {
                    status += entries_overflowed.cell.setValue(temp);
                }
                else
                {
                    status += entries_overflowed.cell.setValue(DEFAULT_VALUE);
                }
                /*--%r WORK_TODO: need to set with PLC date and time rather than PC date & time */    
                status += PLC_date_time.cell.setValue(PLC_Date);
            }
            if (status != OK)
            {
                status = ERROR;
            }
            else
            {
                if ((parseInt(this.faultSummary.num_of_fault_entries.cell.value) !=  (all_faults_parse_array.length - 1)) && (this.faultSummary.num_of_fault_entries.cell.value != DEFAULT_VALUE))
                {
                    status = ERROR;
                }
                else
                {       
    /*--%r 
     *                 FOR each faultN_string element
     *                     pass the row_index and the faultN_string to the faultTable setRow 
     *                             method
     *                     IF the setRow method has an ERROR
     *                         set status to ERROR
     *                         break from FOR loop
     *                     ENDIF the setRow method has an ERROR
     *                 ENDFOR each faultN_string element
     *             ENDIF the number of fault entries value does not equal the number of faults
     *         ENDIF there is an error setting any of the faultSummary properties
     *     ENDIF the number of elements is less than the expected number of summary
     * ENDIF the number of elements is greater than the maximum fault entries
     * IF the status is set to ERROR
     *     IF the reentrant flag is true
     *         restore the state of the fault object setting the reentrant input to false
     *                 so this function cannot be re-entered more than one additional time
     *                 to restore the settings; otherwise, if there were bad data already
     *                 in the fault object, the function would continually recall itself
     *                 and never exit.
     *     ENDIF the reentrant flag is true
     * ENDIF the status is set to ERROR
     * return status
     */
                    for (var i = 1; i < all_faults_parse_array.length; i++)
                    {
                        if (this.faultTable.setRow(all_faults_parse_array[i],(i-1)) == ERROR)
                        {
                            status = ERROR;
                            break;
                        }
                    }
                }    
            }    
        }
    }
    if (status == ERROR)
    {
        if (reentrant_flag == "REENTRANT")
        {
            this.setAllFaults(saved_fault_state, "NOT_REENTRANT");
        }
    }                        
    return status; 
}

/*--%r**************************************************************************
* Function    : Get_all_faults
*
* Description : The purpose of this method is to get all the various fault 
*               object properties and place them in a string that uses the
*               same format as the all_faults_string provided by the PLC.
*               This function is typically called to save the current
*               state of the fault object so that it can be re-stored
*               in case an ERROR occurs in setting the properties. 
*
* Associated
*  Method     : Fault.getAllFaults()all_faults_string
*
* Inputs      : None.
*
* Outputs     : returns a string in the same format as the all_faults_string
*               returned by the PLC from the gef:allFltData function
*
* Global Data
* & Objects
* Accessed    : this.FaultTable.getRow()
*               this.FaultSummary - gets the various elements in the object
*
* Modified
* Global Data
* & Objects   : None
*                   
****************************************************************************/
function Get_all_faults()
{
    /*--%r
     * create header_string from faultSummary properties total_faults, 
     *         number_of_fault_entries and fault_table_cleared_time
     * FOR each row in the fault table
     *     get the fault_string (Note: call faultTable.getRow())
     *     concantenate the fault_string to the header_string using 
     *             the specified separator character
     * ENDFOR each row in the fault table
     * return the all_faults_string
     */
    with (this.faultSummary)
    {
        var header_string = total_faults.cell.value + HEADER_FAULT_SEP + num_of_fault_entries.cell.value + HEADER_FAULT_SEP + fault_table_cleared_time.cell.value;
    }
    var fault_string = "";
    for (var i = 0; i < this.faultTable.num_of_rows; i++)
    {
        fault_string = fault_string + ALL_FAULTS_SEP + this.faultTable.getRow(i);
    }
    return header_string + fault_string;
}
/*--%r**************************************************************************
* Function    : Refresh_fault
*
* Description : The purpose of this method is to dynamically update the display
*               of the entire fault table.   
*
* Associated
*  Method     : Fault.refresh()
*
* Inputs      : None.
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : this.faultSummary.refresh();
*               this.faultTable.refresh();
*               
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Refresh_fault()
{
    /*--%r
     * refresh the faultSummary fault data
     * refresh the faultTable fault data
     */
    this.faultSummary.refresh();
    this.faultTable.refresh();
}

/*--%r**************************************************************************
* Function    : Highlight
*
* Description : This method is called when there is a mouseover or mouseout 
*               event on the body of the page.  This method determines if the 
*               mouseover/mouseout event occurred on the fault table object and 
*               highlights that row of the fault table if the on_off parameter 
*               equals "ON" or unhighlights that row of the fault table if the 
*               on_off parameter equals "OFF".   
*
* Associated
*  Method     : Fault.highlight()
*
* Inputs      : on_off  determines whether the function highlights the row 
*                   ("ON") or unhighlights the row ("OFF").
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : window.event.srcElement.id - to get the ID of the element where
*                   the mouse passed over or out of.
*               
* Modified
* Global Data
* & Objects   : changes styles of the row element passed over by the mouse to:
*                   mainFaultRowElement.style.backgroundColor="lightblue";
*                   mainFaultRowElement.style.color="black";
*			        mainFaultRowElement.style.cursor="hand";
*               changes styles of the row element passed out of by the mouse to:
*                   mainFaultRowElement.style.backgroundColor="White";
*                   mainFaultRowElement.style.color="black";
*			        mainFaultRowElement.style.cursor="default";
*                   
****************************************************************************/
function Highlight(on_off)
{
    /*--%r
     * get the index of the row that was just passed over or out of
     * IF the mouse passed over a row object (it has a valid index)
     *     get the row object associated with that index
     *     IF the row object is found
     *         IF the mouse passed over (on_off = "ON")
     *             assign the row object's background color to light blue
     *             assign the row object's color to black
     *             assign the row object's cursor to a hand
     *         ELSE the mouse passed away from the object (on_off = "OFF")
     *             assign the row object's background color to white
     *             assign the row object's color to black
     *             assign the row object's cursor to the default cursor
     *         ENDIF the mouse passed over (on_off = "ON")
     *     ENDIF the row object is found
     * ENDIF the mouse passed over a row object
     */
	var index;
	index = getTableRow(window.event.srcElement.id);
	if (index != ERROR) 
	{
	    var ParentElement = document.all(MAIN_FAULT_ROW_NAME+index);
	    if (ParentElement)
		{
		    if (on_off == "ON") 
		    {
			    ParentElement.style.backgroundColor="lightblue";
			    ParentElement.style.color="black";
			    ParentElement.style.cursor="hand";
		    }
		    else 
		    {
			    ParentElement.style.backgroundColor="White";
			    ParentElement.style.color="Black";
			    ParentElement.style.cursor="default";
			}    
		}
	}
}

/*--%r**************************************************************************
* Function    : Toggle_extra_fault_display
*
* Description : This method is called when the user clicks the mouse on an element 
*               in the body of the page.  The method determines the location of 
*               the click.  If the click is on a fault table row, the method 
*               expands the extra fault data row so that it can be seen if it 
*               was already collapsed.  If the row was already expanded, the method 
*               collapses the extra fault data row so that it is hidden.   
*
* Associated
*  Method     : Fault.toggleExtraFaultDisplay()
*
* Inputs      : None.
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : window.event.srcElement.id - to get the ID of the element where
*                   the mouse clicked.
*               
* Modified
* Global Data
* & Objects   : extraFaultRow[i].show - where extraFaultRow is the row object
*                   that was clicked on.  The show method alters the HTML className 
*                   property to either collapse or expand the row.  
*                   
****************************************************************************/
function Toggle_extra_fault_display()
{
    /*--%r
     * get the index of the row that was just clicked on
     * IF the mouse clicked on a row object (it has a valid index)
     *     use the show method of the extra fault row based on the index to change
     *             the extra fault rows visibility to the opposite state (if hidden, show;
     *             if showing, hide)
     * ENDIF the mouse clicked on a row object
     */
    if (browser_refresh)
	{
	    var index = getTableRow(window.event.srcElement.id);
	    if (index != ERROR) 
	    {
		    this.faultTable.extraFaultRow[index].show(!this.faultTable.extraFaultRow[index].show_fault);
	    }
	}    	
}

/*--%r**************************************************************************
* Function    : Change_extra_fault_display
*
* Description : This method is called when the user clicks on the Show All 
*               checkbox.  The method expands all fault table extra fault data 
*               rows so they can be seen if the Show All checkbox is checked.  
*               Alternatively, it collapses all extra fault data rows if the Show 
*               All checkbox is unchecked.   
*
* Associated
*  Method     : Fault.changeExtraFaultDisplay()
*
* Inputs      : checked - this is the state of the show all checkbox; true indicateds
*                   checked and false indicates unchecked.
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : Fault.extraFaultControl.getShowAll
*               
* Modified
* Global Data
* & Objects   : Fault.faultTable.extraFaultRow.collapseExpand
*                   
****************************************************************************/
function Change_extra_fault_display(checked)
{
    /*--%r
     * set the value of the show_all property in the Fault.extraFaultControl
     *     object with the value of the Show All checkbox
     * IF the browser supports dynamic refresh
     *     FOR every row in the fault table
     *         use the show method of the extra fault row object and show or
     *                 hide based on the extra fault control show_all property
     *                 value (true or false).
     *     ENDFOR every row in the fault table
     * ENDIF the browser supports dynamic refresh
     */
    this.extraFaultControl.setShowAll(checked);
    if (browser_refresh)
    {
        for (var j = 0; j < this.faultTable.num_of_rows ; j++)
	    {
		    this.faultTable.extraFaultRow[j].show(checked);
		}    
	}
}

/*--%r**************************************************************************
* Function    : Change_extra_fault_format
*
* Description : This method is called when the user clicks on one of the extra 
*               fault data format radio buttons.   Based on the value of the 
*               selected radio button (BYTE, WORD, ASCII), the method changes 
*               the extra fault data value to a new value based on the new 
*               format and then displays the new value.   
*
* Associated
*  Method     : Fault.changeExtraFaultFormat()
*
* Inputs      : value - contains the value of the clicked radio button.  Valid
*                   values are BYTE, WORD and ASCII
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : Fault.extraFaultControl.getFormat
*               
* Modified
* Global Data
* & Objects   : Fault.faultTable.extraFaultRow[i].fault_extra_data.setFormat
*               Fault.faultTable.extraFaultRow[i].fault_extra_data.refresh  
*                   
****************************************************************************/
function Change_extra_fault_format(value)
{
    /*--%r
     * set the format property of the fault_extra_data object equal to the 
     *     radio button selection
     * IF there is not an error setting the format
     *     IF the browser supports dynamic refresh
     *         update extra fault data display using the new format
     *     ENDIF the browser supports dynamic refresh
     *     Note:  According to UIS, for browsers that don't support dynamic
     *         refresh such as Netscape, we should not automatically refresh
     *         the screen because this gets new fault data and potentially loses
     *         data currently being displayed.  The user must press the refresh
     *         button when updated fault data is needed.  This, however, means that
     *         if the user has not selected to display extra fault data, they
     *         may never get to see this information since it could be overwritten
     *         by the new fault data during the refresh operation.
     * ENDIF there is not an error setting the format
     */
    if (this.extraFaultControl.setFormat(value) != ERROR)
    {
        if (browser_refresh)
        {
            for (var i = 0; i < fault.faultTable.num_of_rows; i++)
            {
                fault.faultTable.extraFaultRow[i].fault_extra_data.setFormat(value);
                fault.faultTable.extraFaultRow[i].fault_extra_data.refresh();
            }
        }
    }            
}

/*--%r**************************************************************************
* Function    : Create_fault_summary_HTML
*
* Description : This method creates the HTML output for the fault summary object
*               which causes the browser to draw the fault summary table on the 
*               user's screen.   
*
* Associated
*  Method     : FaultSummary.createHTML()
*
* Inputs      : None.
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : FaultSummary.total_faults.createHTML
*               FaultSummary.num_of_fault_entries.createHTML
*               FaultSummary.fault_table_cleared_time.createHTML
*               FaultSummary.PLC_date_time.createHTML
*               FaultSummary.entries_overflowed.createHTML  
*                   
****************************************************************************/
function Create_fault_summary_HTML()
{
    /*--%r
     * create HTML output for the table with a border around the table
     * create HTML output for the beginning of the first row and the
     *     total faults label cell.
     * create HTML output for the total_faults object
     * create HTML output to end the previous row, beginning of next row
     *     and the num_of_fault_entries label cell
     * create HTML output for the num_of_fault_entries object
     * create HTML output to end the previous row, beginning of next row
     *     and the entries overflowed label cell
     * create HTML output for the entries_overflowed object
     * create HTML output to end the previous row, beginning of next row
     *     and the fault_table_cleared_time label cell
     * create HTML output for the fault_table_cleared_time object
     * create HTML output to end the previous row, beginning of next row
     *     and the PLC_date_time label cell
     * create HTML output for the PLC_date_time object
     * create HTML output to end the previous row
     * create HTML output to end the table
     */
    with (document)
    {
        if (browser_type == NETSCAPE)
        {
            write('<table border="1" width="65%" align=center bgcolor="white"  cellpadding=0 cellspacing=0 style="border-style: solid">');
        }
        else
        {
            write('<table border="0" width="65%" style="border-style: solid">');
        }    
        write('<tr>');
        write('<td width="60%" nowrap class = "faultStyle1">' + TOTAL_FAULTS_LABEL + '</td>');
        this.total_faults.createHTML();
        write('</tr><tr>');
        write('<td width="57%" nowrap class = "faultStyle1">' + TOTAL_FAULTS_DISPLAYED_LABEL + '</td>');
        this.num_of_fault_entries.createHTML();
        write('</tr><tr>');
        write('<td width="57%" nowrap class = "faultStyle1">' + ENTRIES_OVERFLOWED_LABEL + '</td>');
        this.entries_overflowed.createHTML();
        write('</tr><tr>');
        write('<td width="57%" nowrap class = "faultStyle1" >' + TABLE_LAST_CLEARED_LABEL + '</td>');
        this.fault_table_cleared_time.createHTML();
        write('</tr><tr>');
        write('<td width="57%" nowrap class = "faultStyle1">' + PLC_DATE_TIME_LABEL + '</td>');
        this.PLC_date_time.createHTML();
        write('</tr></table>');
    }    
}

/*--%r**************************************************************************
* Function    : Refresh_fault_summary
*
* Description : The purpose of this method is to dynamically update the fault 
*               summary object with new values from the PLC.   
*
* Associated
*  Method     : FaultSummary.refresh()
*
* Inputs      : None.
*
* Outputs     : This method returns OK if the browser supports dynamic refresh.  
*               Otherwise, the method returns ERROR.
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : FaultSummary.total_faults.cell.refresh
*               FaultSummary.num_of_fault_entries.cell.refresh
*               FaultSummary.fault_table_cleared_time.cell.refresh
*               FaultSummary.PLC_date_time.cell.refresh
*               FaultSummary.entries_overflowed.cell.refresh  
*                   
****************************************************************************/
function Refresh_fault_summary()
{
    /*--%r
     * update the display for the total_faults object
     * update the display for the num_of_fault_entries object
     * update the display for the entries_overflowed object
     * update the display for the fault_table_cleared_time object
     * update the display for the PLC_date_time object
     */
    this.total_faults.cell.refresh();
    this.num_of_fault_entries.cell.refresh();
    this.entries_overflowed.cell.refresh();
    this.fault_table_cleared_time.cell.refresh();
    this.PLC_date_time.cell.refresh();
}

/*--%r**************************************************************************
* Function    : Create_fault_table_HTML
*
* Description : This method creates the HTML for the fault table object which
*               causes the browser to draw the fault table on the user's 
*               screen.   
*
* Associated
*  Method     : FaultTable.createHTML()
*
* Inputs      : None.
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : FaultTable.mainFaultRow.createHTML()
*               FaultTable.mainFaultRow.createHTML()
*                   
****************************************************************************/
function Create_fault_table_HTML()
{
    /*--%r
     * create the HTML output for the table header
     */
    with (document)
    {
        if (this.type == "PLC")
        {
            write('<table border=1 bordercolor=black cellspacing=0 cellpadding=2 width=100% align=center>');
            write('<tr>');
	        write('<td bgcolor="blue" align=center colspan=3 id="PLCTitle" class="PLCTitle">' + PLC_FAULT_TABLE_LABEL + '</font></td>');
            write('</tr><tr>');
	        write('<td class="tableheader" width="10%">' + LOCATION_LABEL + '<br>' + RACK_SLOT_LABEL + '</td>');
	        write('<td class="tableheader" width="60%">&nbsp;' + FAULT_DESCRIPTION_LABEL + '</td>');
	        write('<td class="tableheader" width="25%">' + DATE_TIME_LABEL + '</td>');
            write('</tr>');
        }
        else
        {
            write('<table border=1 bordercolor=black cellspacing=0 cellpadding=2 width=100% align=center>');
            write('<tr>');
	        write('<td bgcolor="blue" align=center colspan=6 id="PLCTitle" class="PLCTitle">' + IO_FAULT_TABLE_LABEL + '</td>');
            write('</tr><tr>');
	        write('<td class="tableheader" width="58">' + LOCATION_LABEL + '<br>' + RACK_SLOT_LABEL + '</td>');
	        write('<td class="tableheader" width="43">' + CIRC_NO_LABEL + '</td>');
	        write('<td class="tableheader" width="67">' + REF_ADDR_LABEL + '</td>');
	        write('<td class="tableheader" width="223">' + FAULT_CATEGORY_LABEL + '</td>');
	        write('<td class="tableheader" width="182">' + FAULT_TYPE_LABEL + '</td>');
	        write('<td class="tableheader" width="105">' + DATE_TIME_LABEL + '</td>');
            write('</tr>');
        }
    /*--%r
     * FOR each row in the FaultTable object
     *     create the HTML output for the mainFaultRow object
     *     IF the browser type is not NETSCAPE or the browser type is Netscape and the extraFault 
     *             show_fault property is true (Note:  Netscape does not show the main fault rows
     *                                                 correctly when the extra fault rows as specified
     *                                                 as hidden; therefore don't create the extra
     *                                                 fault rows if they shouldn't be shown)
     *         create the HTML output for the extraFault Row object
     *     ENDIF the browser type is not NETSCAPE ....
     *     ELSE the browser type is NETSCAPE
     * ENDFOR each row in the FaultTable object 
     * create the HMTL output for the end of the table
     */
        for (var i = 0; i < this.num_of_rows; i++)
        {
            /*--%r#if debug */
            log_event("creating main row");
            /*--%r#endif */
            this.mainFaultRow[i].createHTML();
            if ((browser_type != NETSCAPE)||((browser_type == NETSCAPE)&&(this.extraFaultRow[i].show_fault == true)))
            {
                /*--%r#if debug */
                log_event("creating extra fault row");
                /*--%r#endif */
                this.extraFaultRow[i].createHTML();
                /*--%r In IE, we use a div class called "clsCollapsed" which uses the style "display:none"
                       to hide the extra fault rows.  However, if this style is used in Netscape, Netscape
                       does not display the rest of the fault table correctly.  Therefore, we don't create
                       the extra rows in Netscape if the extra fault is not going to be displayed */
            }    
        }
        /*--%r#if debug */
        log_event("before end of fault table");
        /*--%r#endif */
        write('</table>');
        /*--%r#if debug */
        log_event("after end of fault table");                
        /*--%r#endif */
    }        
}

/*--%r**************************************************************************
* Function    : Set_row
*
* Description : This method sets the properties of the mainFaultRow and extraFault
*               row object based on a row fault_string extracted from the 
*               all_faults_string.   
*
* Associated
*  Method     : FaultTable.setRow()
*
* Inputs      : fault_row_string - represents fault data for one fault row.
*               index - indicates which fault table row is to be set
*
* Outputs     : This function returns OK if the all elements are set 
*               without an error.  It returns ERROR if any element cannot be 
*               set.
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : FaultTable.mainFaultRow[index] properties are set.
*               FaultTable.extraFaultRow[index] properties are set.
*                   
****************************************************************************/
function Set_row(fault_row_string, index)
{
    var row_string_parse_array; /*--%r array to hold the elements of the fault row */
    /*--%r
     * set status to OK
     * IF the fault table type is PLC
     *     breakdown the fault_row_string into location, fault
     *         description, fault_date, fault_time, long_short, task, group
     *         action, error_code and extra_fault_data
     *     IF the number of elements is less than the expected number
     *             (Note: don't want this to break if we add a new element later,
     *              so we only check if we don't have enough elements)
     *         set the status to ERROR
     *     ELSE the number of elements is equal or greater than the expected number
     */
    var status = OK;
    if (this.type == "PLC")
    {
        row_string_parse_array = fault_row_string.split(HEADER_FAULT_SEP);
        if (row_string_parse_array.length < MIN_PLC_FAULT_TABLE_ROW_ELEMENTS)
        {
            status = ERROR;
        }
        else
        {    
     
    /*--%r 
     *         assign the location, fault description, fault_date, fault_time, long_short, 
     * 			task, group, action, 
     * 			IF error_code is greater than MAX_ERROR_CODE_VALUE 
     * 				find difference and multiply by 2
     *				NOT the error_code value + 1 (Two's Compliment) 
     *				Add the difference.  Assign the error_code.
     *			ELSE	Assign the error_code to the corresponding property.		 
     *		       Assign extra_fault_data to the corresponding property 
     *                 in either the mainFaultRow[index] or extraFaultRow[index] objects.
     *         IF setting any of the properties causes an ERROR
     *             set the status to ERROR
     *         ENDIF setting any of the properties causes an ERROR
     *     ENDIF the number of elements is less than the expected number 
     * ELSE the fault table type is IO
     */
            with (this.mainFaultRow[index])
            {
                status += location.cell.setValue(row_string_parse_array[PLC_LOCATION_INDEX]);
                status += fault_description.cell.setValue(unescape(row_string_parse_array[PLC_FAULT_DESCRIPTION_INDEX]));
                if (row_string_parse_array[PLC_FAULT_DATE_INDEX]!="")
                {
                    status += fault_date_time.cell.setValue(row_string_parse_array[PLC_FAULT_DATE_INDEX] + FAULT_DATE_TIME_SEP + row_string_parse_array[PLC_FAULT_TIME_INDEX]);
                }
                else
                {
                    status += fault_date_time.cell.setValue(DEFAULT_VALUE);
                }
            }
            with (this.extraFaultRow[index])
            {
                status += long_short.cell.setValue(row_string_parse_array[PLC_LONG_SHORT_INDEX]);
                status += task.cell.setValue(row_string_parse_array[PLC_TASK_INDEX]);
                status += group.cell.setValue(row_string_parse_array[PLC_GROUP_INDEX]);
                status += action.cell.setValue(row_string_parse_array[PLC_ACTION_INDEX]+GetFaultActionText(parseInt(row_string_parse_array[PLC_ACTION_INDEX])-1));

		if (row_string_parse_array[PLC_ERROR_CODE_INDEX] > MAX_ERROR_CODE_VALUE)
		{
		    difference = (row_string_parse_array[PLC_ERROR_CODE_INDEX] - MAX_ERROR_CODE_VALUE) * 2;
		    status += error_code.cell.setValue((~row_string_parse_array[PLC_ERROR_CODE_INDEX]+1) + difference);
		}
		else
		{
		   status += error_code.cell.setValue(row_string_parse_array[PLC_ERROR_CODE_INDEX]);
		}
                status += fault_extra_data.setValue(row_string_parse_array[PLC_FAULT_EXTRA_DATA_INDEX]);
            }
            if (status != OK)
            {
                status = ERROR;
            }
        }
    }    
    else
    {            
     
    /*--%r 
     *     breakdown the fault_row_string into location, 
     *         circ_number, ref_addr, fault_category, fault_type, fault_date,
     *         fault_time, long_short, io_bus, bus, point, group, action, 
     *         fault_category_number, fault_type_number, extra_fault_data
     *     IF the number of elements is less than the expected number
     *             (Note: don't want this to break if we add a new element later,
     *              so we only check if we don't have enough elements)
     *         set the status to ERROR
     *     ELSE the number of elements is equal or greater than the expected number
     */
        row_string_parse_array = fault_row_string.split(HEADER_FAULT_SEP);
        if (row_string_parse_array.length < MIN_IO_FAULT_TABLE_ROW_ELEMENTS)
        {
            status = ERROR;
        }
        else
        {    
    /*--%r 
     *         assign the location, circ_number, ref_addr, 
     *                 fault_category, fault_type, fault_date,
     *                 fault_time, long_short, io_bus, bus, point, group, action, 
     *                 fault_category_number, fault_type_number, extra_fault_data 
     *                 to their corresponding property in either the mainFaultRow[index] 
     *                 or extraFaultRow[index] objects
     *                 IF Bus Address is 127 
     *                    Set the Bus Address to n/a
     *                 IF Point Address is  32767
     *                    Set the IO Point to n/a
     *         IF setting any of the properties causes an ERROR
     *             set the status to ERROR
     *         ENDIF setting any of the properties causes an ERROR
     *     ENDIF the number of elements is less than the expected number 
     * ENDIF the fault table type is PLC
     * return status
     */
            with (this.mainFaultRow[index])
            {
                status += location.cell.setValue(row_string_parse_array[IO_LOCATION_INDEX]);
                status += circ_number.cell.setValue(row_string_parse_array[IO_CIRC_NUMBER_INDEX]);
                status += ref_addr.cell.setValue(row_string_parse_array[IO_REF_ADDR_INDEX]);
                status += fault_category.cell.setValue(unescape(row_string_parse_array[IO_FAULT_CATEGORY_INDEX]));
                status += fault_type.cell.setValue(unescape(row_string_parse_array[IO_FAULT_TYPE_INDEX]));
                if (row_string_parse_array[IO_FAULT_DATE_INDEX] != "")
                {
                    status += fault_date_time.cell.setValue(row_string_parse_array[IO_FAULT_DATE_INDEX] + FAULT_DATE_TIME_SEP + row_string_parse_array[IO_FAULT_TIME_INDEX]);
                }
                else
                {
                    status += fault_date_time.cell.setValue(DEFAULT_VALUE);
                }
            }
            with (this.extraFaultRow[index])
            {
                status += long_short.cell.setValue(row_string_parse_array[IO_LONG_SHORT_INDEX]);
                
                if( parseInt(row_string_parse_array[IO_IO_BUS_INDEX]) == 127)
                    status += io_bus.cell.setValue("n/a"); 
                else
                    status += io_bus.cell.setValue(row_string_parse_array[IO_IO_BUS_INDEX]);  
                
                
                if( parseInt(row_string_parse_array[IO_BUS_INDEX]) == 127)
                    status += bus.cell.setValue("n/a"); 
                else
                    status += bus.cell.setValue(row_string_parse_array[IO_BUS_INDEX]);
                

                if( parseInt(row_string_parse_array[IO_POINT_INDEX]) == 32767)
                   status += point.cell.setValue("n/a");
                else
                   status += point.cell.setValue(row_string_parse_array[IO_POINT_INDEX]);
                
                status += group.cell.setValue(row_string_parse_array[IO_GROUP_INDEX]);
                status += action.cell.setValue(row_string_parse_array[IO_ACTION_INDEX]+GetFaultActionText(parseInt(row_string_parse_array[IO_ACTION_INDEX])-1));
                status += fault_category_number.cell.setValue(row_string_parse_array[IO_FAULT_CATEGORY_NUMBER_INDEX]);
                status += fault_type_number.cell.setValue(row_string_parse_array[IO_FAULT_TYPE_NUMBER_INDEX]);
                status += fault_extra_data.setValue(row_string_parse_array[IO_FAULT_EXTRA_DATA_INDEX]);
            }
            if (status != OK)
            {
                status = ERROR;
            }
        }
    }
    return status;    
}
/*--%r**************************************************************************
* Function    : Get_row
*
* Description : This method gets the properties of the mainFaultRow and extraFault
*               row object and creates row fault_string in the format specified
*               by the gef:AllFltData function
*
* Associated
*  Method     : FaultTable.getRow()
*
* Inputs      : index - indicates which fault table row to get
*               
*
* Outputs     : fault_row_string - represents fault data for one fault row.
*
* Global Data
* & Objects
* Accessed    : FaultTable.mainFaultRow[index] properties are read.
*               FaultTable.extraFaultRow[index] properties are read.
*               
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Get_row(index)
{
    var fault_row_string = ""; /*--%r string to hold the fault row values */
    var date_time_parse_array = new Array(); /*--%r array for breaking part the PLC_date_time value
                                              *      into a date and time field */                          
    /*--%r
     * break the fault_date_time property in to date and time elements
     * IF the fault_date_time property does not contain a date and time
     *     set the date and time to ""
     * ENDIF the fault_date_time property does not contain a date and time
     * IF the fault table type is PLC
     *     create a fault_row_string containing the value of the following 
     *         properties in either the mainFaultRow[index]
     *         or extraFaultRow[index] objects: location, fault
     *         description, fault_date, fault_time, long_short, task, group
     *         action, error_code and extra_fault_data
     * ELSE the fault table type is IO
     *     create a fault_row_string containing the value of the following 
     *         properties in either the mainFaultRow[index]
     *         or extraFaultRow[index] objects: location, 
     *         circ_number, ref_addr, fault_category, fault_type, fault_date,
     *         fault_time, long_short, io_bus, bus, point, group, action, 
     *         fault_category_number, fault_type_number, extra_fault_data
     * ENDIF the fault table type is PLC
     * return fault_row_string
     */
    date_time_parse_array =  this.mainFaultRow[index].fault_date_time.cell.value.split(FAULT_DATE_TIME_SEP);
    if (date_time_parse_array.length != 2)
    {
        date_time_parse_array[DATE_INDEX] = "";
        date_time_parse_array[TIME_INDEX] = "";
    }   
    if (this.type == "PLC")
    {
        with (this.mainFaultRow[index])
        {
            fault_row_string += location.cell.value + HEADER_FAULT_SEP;
            fault_row_string += fault_description.cell.value +  HEADER_FAULT_SEP;
            fault_row_string += date_time_parse_array[DATE_INDEX] + HEADER_FAULT_SEP;
            fault_row_string += date_time_parse_array[TIME_INDEX] + HEADER_FAULT_SEP;
        }
        with (this.extraFaultRow[index])
        {    
            fault_row_string += long_short.cell.value + HEADER_FAULT_SEP;
            fault_row_string += task.cell.value +  HEADER_FAULT_SEP;
            fault_row_string += group.cell.value + HEADER_FAULT_SEP;
            fault_row_string += action.cell.value + HEADER_FAULT_SEP;
            fault_row_string += error_code.cell.value + HEADER_FAULT_SEP;
            fault_row_string += fault_extra_data.value;
        }
    }
    else
    {
        with (this.mainFaultRow[index])
        {
            fault_row_string += location.cell.value + HEADER_FAULT_SEP;
            fault_row_string += circ_number.cell.value +  HEADER_FAULT_SEP;
            fault_row_string += ref_addr.cell.value +  HEADER_FAULT_SEP;
            fault_row_string += fault_category.cell.value +  HEADER_FAULT_SEP;
            fault_row_string += fault_type.cell.value +  HEADER_FAULT_SEP;
            fault_row_string += date_time_parse_array[DATE_INDEX] + HEADER_FAULT_SEP;
            fault_row_string += date_time_parse_array[TIME_INDEX] + HEADER_FAULT_SEP;
        }
        with (this.extraFaultRow[index])
        {    
            fault_row_string += long_short.cell.value + HEADER_FAULT_SEP;
            fault_row_string += io_bus.cell.value +  HEADER_FAULT_SEP;
            fault_row_string += bus.cell.value + HEADER_FAULT_SEP;
            fault_row_string += point.cell.value + HEADER_FAULT_SEP;
            fault_row_string += group.cell.value + HEADER_FAULT_SEP;
            fault_row_string += action.cell.value + HEADER_FAULT_SEP;
            fault_row_string += fault_category_number.cell.value + HEADER_FAULT_SEP;
            fault_row_string += fault_type_number.cell.value + HEADER_FAULT_SEP;
            fault_row_string += fault_extra_data.value;
        }
    }    
    return fault_row_string;
}

/*--%r**************************************************************************
* Function    : Refresh_fault_table
*
* Description : The purpose of this method is to dynamically update the fault 
*               table object with new values from the PLC.   
*
* Associated
*  Method     : FaultTable.refresh()
*
* Inputs      : None.
*
* Outputs     : This method returns OK if the browser supports dynamic refresh.  
*               Otherwise, the method returns ERROR.
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : FaultTable.mainFaultRow[i].refresh()
*               FaultTable.extraFaultRow[i].refresh()
*                   
****************************************************************************/
function Refresh_fault_table()
{
    /*--%r
     * set status to OK
     * IF browser supports dynamic refresh
     *     FOR each row in the fault table
     *         update the fault data in the main fault row
     *         update the fault data in the extra fault row
     *     ENDFOR each row in the fault table
     * ELSE browser does not support dynamic refresh
     *     set status to ERROR
     * ENDIF browser supports dynamic refresh
     * return status
     */
    var status = OK;
    if (browser_refresh)
    {
        for (var i = 0; i < this.num_of_rows; i++)
        {
            this.mainFaultRow[i].refresh();
            this.extraFaultRow[i].refresh();
        }
    }
    else
    {
        status = ERROR;
    }
    return status;            
}

/*--%r**************************************************************************
* Function    : Create_extra_fault_control_HTML
*
* Description : This method creates the HTML output for the 
*               extra fault control portion of the screen.   
*
* Associated
*  Method     : ExtraFaultControl.createHTML()
*
* Inputs      : None.
*
* Outputs     : None.
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Create_extra_fault_control_HTML()
{
    /*--%r
     * create HTML output for extra fault control table and header
     * create HTML output for Show All checkbox
     * create HTML output for format radio buttons
     * create HTML output for end of table
     * force HTML output
     * set the HTML_created property so that the setShowAll & setFormat properties
     *     can access the Show All checkbox and the format radio button elements
     * set the Show All checkbox with the value contained in the show_all property
     * set the format radio button with the value contained in the format property
     */
    with (document)
    {
        write('<table width="100%" align=center bgcolor="white" border=1 height=1 cellpadding=0 cellspacing=0>');
		write('<tr>');
		write('<td align="center" nowrap class="tableheader2"><font face="verdana" size="1"><b>' + FAULT_EXTRA_DATA_LABEL + '</b></font></td>');
		write('<td align="center" nowrap class="tableheader2"><font face="verdana" size="1"><b>' + FAULT_EXTRA_DATA_FORMAT_LABEL + '</b></font></td>');
		write('</tr><tr>');
        write('<td nowrap><input type="checkbox" name="showAll" value="OFF" OnClick = "fault.changeExtraFaultDisplay(this.checked);"><font face="verdana" size="1">' + SHOW_ALL_LABEL + '</font></td>');
        write('<td><font face=verdana size=1>');
		write('<input type="radio" name="extraDataFormat" value="0" checked onclick="fault.changeExtraFaultFormat(BYTE);">' + BYTE_LABEL + '&nbsp;<br>');
		write('<input type="radio" name="extraDataFormat" value="1" onclick="fault.changeExtraFaultFormat(WORD);">' + WORD_LABEL + '&nbsp;<br>');
		write('<input type="radio" name="extraDataFormat" value="2" onclick="fault.changeExtraFaultFormat(ASCII);">' + ASCII_LABEL + '</font></td>');
        write('</tr></table>');
    }
    this.HTML_created = true;
    this.setShowAll(this.show_all);
    this.setFormat(this.format);
}

/*--%r**************************************************************************
* Function    : Set_show_all
*
* Description : The purpose of this method is to check or uncheck the Show All 
*               check box and to set the show_all property to the same state.  
*
* Associated
*  Method     : ExtraFaultControl.setShowAll()
*
* Inputs      : checked  A value of true causes the Show All checkbox to 
*                   be checked and the show_all property to be set to true.  
*                   A value of false causes the Show All checkbox 
*                   to be unchecked and the show_all property to be set to false.
*
* Outputs     : Returns OK if the input is valid and ERROR otherwise
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : document.faultForm.showAll.checked
*                   
****************************************************************************/
function Set_show_all(checked)
{
    /*--%r
     * set status to OK
     * IF the "checked" input variable does not equal true or false
     *     set status to ERROR
     * ELSE the "checked" input variable is valid
     *     set the show_all property to equal to "checked" input variable
     *     IF the HTML has been created for the Show All checkbox 
     *         set the Show All checkbox to the same status as the "checked" input variable
     *     ENDIF the HTML has been created for the Show All checkbox
     * ENDIF the "checked" input variable does not equal true or false
     * return status
    */
    var status = OK;
    if ((checked != true)&&(checked != false))
    {
        status = ERROR;
    }
    else
    {
        this.show_all = checked;
        if (this.HTML_created)
        {
            document.faultForm.showAll.checked = checked;
        }
    }                
    return status;     
}

/*--%r**************************************************************************
* Function    : Get_show_all
*
* Description : The purpose of this method is to get the current status of the 
*               Show All check box and to set the show_all property to equal
*               the value of the Show All checkbox.  
*
* Associated
*  Method     : ExtraFaultControl.getShowAll()
*
* Inputs      : None.
*
* Outputs     : The method returns true if the Show All checkbox is checked 
*               and returns false if the checkbox is unchecked.
*
* Global Data
* & Objects
* Accessed    : document.faultForm.showAll.checked
*               
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Get_show_all()
{
    /*--%r
     * IF the HTML has been created for the Show All checkbox
     *     set the show_all property to equal the value of the Show All checkbox
     *             so that they are synchronized
     * ENDIF the HTML has been created for the Show All checkbox
     * return show_all property
     */
    if (this.HTML_created)
    {
        this.show_all = document.faultForm.showAll.checked;
    }
    return this.show_all;         
}

/*--%r**************************************************************************
* Function    : Set_format
*
* Description : The purpose of this method is to set the extra fault data 
*               format radio buttons.  The valid values are BYTE, WORD, or 
*               ASCII.    
*
* Associated
*  Method     : ExtraFaultControl.setFormat()
*
* Inputs      : new_format  the format to apply to the radio buttons.
*
* Outputs     : OK if the value is set and ERROR if the format is invalid.
*
* Global Data
* & Objects
* Accessed    : None.
*               
* Modified
* Global Data
* & Objects   : document.faultForm.extraDataFormat[i].checked
*                   
****************************************************************************/
function Set_format(new_format)
{
    /*--%r
     * set the status to OK
     * IF the format is BYTE, WORD, or ASCII
     *     set the format property to equal the new_format
     *     IF the HTML has been created for the extra data format radio buttons
     *         set extra data format button corresponding to the new_format value
     *     ENDIF the HTML has been created for the extra data format radio buttons
     * ELSE the format is not BYTE, WORD or ASCII
     *    set the status to ERROR
     * ENDIF the format is BYTE, WORD, or ASCII
     * return status
     */
    var status = OK;
    if ((new_format == BYTE)||(new_format == WORD)||(new_format == ASCII))
    {
        this.format = new_format;
        if (this.HTML_created)
        {
            document.faultForm.extraDataFormat[new_format].checked = true;
        }
    }
    else
    {
        status = ERROR;
    }
    return status                      
}

/*--%r**************************************************************************
* Function    : Get_format
*
* Description : The purpose of this method is get the current state of the 
*               extra fault data format radio buttons.  
*
* Associated
*  Method     : ExtraFaultControl.getFormat()
*
* Inputs      : None.
*
* Outputs     : This method returns BYTE, WORD, or ASCII.  These are defined 
*               in the Constants section. 
*
* Global Data
* & Objects
* Accessed    : document.faultForm.extraDataFormat[i].checked
*               
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Get_format()
{
    /*--%r
     * IF the HTML has been created for the extra data format radio buttons
     *     set the format property to equal the value of the selected extra 
     *          data format radio button
     * ENDIF the HTML has been created for the extra data format radio buttons
     * return format property
     */
    if (this.HTML_created)
    {
        for (var i = 0; i < document.faultForm.extraDataFormat.length; i++)
        {
            if (document.faultForm.extraDataFormat[i].checked == true)
            {
                this.format = i;
                break;
            }
        }
    }
    return this.format;                 
}

/*--%r**************************************************************************
* Function    : Store_to_cookie
*
* Description : The purpose of this method is to store the current state of 
*               the Show All checkbox and the Extra Data Fault radios buttons 
*               to a cookie.    
*
* Associated
*  Method     : ExtraFaultControl.storeToCookie()
*
* Inputs      : None.
*
* Outputs     : Returns OK if the cookie is saved properly.  Otherwise, the 
*               function returns ERROR. 
*
* Global Data
* & Objects
* Accessed    : document.faultForm.extraDataFormat[i].checked
*               document.faultForm.showAll.checked
*               
* Modified
* Global Data
* & Objects   : document.cookie = "extra_fault=show_all:format;
*                                  expires=Sun, 31 Dec 2023 05:00:00 UTC"
*                   where show_all = true or false and format = BYTE,
*                   WORD or ASCII as defined in the Constants section. 
*                   
****************************************************************************/
function Store_to_cookie()
{
    /*--%r
     * set status to OK
     * make a string containing the values obtained from the getShowAll and 
     *         getFormat methods.
     * store this string as a cookie named extra_fault
     * read back the cookie
     * IF the cookie read back does not equal the value written or the cookie
     *         does not exist
     *     set status to ERROR
     * ENDIF the cookie read back does not equal the value written ...
     * return status
     */
    var cookie_value = this.getShowAll() + EXTRA_FAULT_COOKIE_SEP + this.getFormat();
    return storeCookie(EXTRA_FAULT_COOKIE_NAME, cookie_value);
}

/*--%r**************************************************************************
* Function    : Set_from_cookie
*
* Description : The purpose of this method is to set the Show All checkbox 
*               and the Extra Fault Data format radio buttons based on values 
*               stored in a cookie.    
*
* Associated
*  Method     : ExtraFaultControl.setFromCookie()
*
* Inputs      : None.
*
* Outputs     : Returns OK if the cookie can be read and the values 
*               within the cookie set the Show All checkbox and Extra 
*               Fault Data format radio buttons correctly.  Otherwise, 
*               the function returns ERROR. 
*
* Global Data
* & Objects
* Accessed    : document.cookie with cookie name of "extra_fault" containing
*                   values "show_all:format"
*                   where show_all = true or false and format = BYTE,
*                   WORD or ASCII as defined in the Constants section.
*
* Modified
* Global Data
* & Objects   : document.faultForm.extraDataFormat[i].checked
*               document.faultForm.showAll.checked
 
*                   
****************************************************************************/
function Set_from_cookie()
{
    /*--%r
     * set status to OK
     * IF the cookie "extra_fault" exists
     *      save the show_all and format properties to local variables in
     *             case there is an error and they need to be re-stored
     *      break the cookie into show_all and format parts
     *      IF the cookie value doesn't contain a show_all and format element
     *          set the status to ERROR
     *      ELSE the cookie value does contain a show_all and format element
     *          convert show_all true/false string to a true/false boolean value
     *          use the show_all cookie value to set the Show All checkbox
     *              & show_all property
     *          IF there is an error setting the Show All checkbox & show_all property or
     *                  setting the extra fault format radio button & format property
     *              set the status to ERROR
     *              re-store the show_all and format properties
     *          ENDIF there is an error setting ....
     *      ENDIF the cookie value doesn't contain a show_all and format element
     * ELSE the cookie "extra_fault" does not exist
     *     set status to ERROR
     * ENDIF the cookie "extra_fault" exists
     * return status
     */
    var status = OK;
    var read_cookie = readCookie(EXTRA_FAULT_COOKIE_NAME);
    if (read_cookie != ERROR)
    {
        var local_show_all = this.getShowAll();
        var local_format = this.getFormat();
        var cookie_parse_string_array = read_cookie.split(EXTRA_FAULT_COOKIE_SEP);
        if (cookie_parse_string_array.length != EXTRA_FAULT_COOKIE_LENGTH)
        {
            status = ERROR;
        }
        else
        {    
            if (cookie_parse_string_array[SHOW_ALL_INDEX] == "true")
            {
                cookie_parse_string_array[SHOW_ALL_INDEX] = true;
            }
            else
            {
                cookie_parse_string_array[SHOW_ALL_INDEX] = false;
            }    
            if ((this.setShowAll(cookie_parse_string_array[SHOW_ALL_INDEX]) == ERROR)||(this.setFormat(parseInt(cookie_parse_string_array[FORMAT_INDEX])) == ERROR))
            {
                status = ERROR;
                this.setShowAll(local_show_all);
                this.setFormat(local_format);
            }
        }
    }
    else
    {
        status = ERROR;
    }
    return status;
}

/*--%r**************************************************************************
* Function    : Create_fault_summary_cell_HTML
*
* Description : This method creates the HTML output for the 
*               fault summary cell portion of the screen.    
*
* Associated
*  Method     : FaultSummaryCell.createHTML()
*
* Inputs      : None.
*
* Outputs     : None. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
****************************************************************************/
function Create_fault_summary_cell_HTML()
{
    /*--%r
     * create HTML output for FaultSummary Cell using the value property of 
     *     the cell for the display within the cell. 
     */
    if (browser_type == NETSCAPE)
    {
        document.write('<td width="43%" nowrap class="faultStyle2" id="' + this.cell.cell_name + '">' + '&nbsp;' + this.cell.value + '</td>');
    }
    else
    {
        document.write('<td width="43%" nowrap class="faultStyle1" id="' + this.cell.cell_name + '">' + this.cell.value + '</td>');
    }
    /*--%r Note:  the code assumes browsers that we currently don't know about will
     *     work more like IE than Netscape.
     */    
}

/*--%r**************************************************************************
* Function    : Refresh_main_fault_row
*
* Description : The purpose of this method is to dynamically update the 
*               display of a row of the fault table with the main fault information.    
*
* Associated
*  Method     : MainFaultRow.refresh()
*
* Inputs      : None.
*
* Outputs     : OK is returned if the browser supports dynamic 
*               update.  Otherwise, the function returns ERROR. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : MainFaultRow.location.cell.refresh()
*               MainFaultRow.fault_description.cell.refresh()
*               MainFaultRow.fault_date_time.cell.refresh()
*               MainFaultRow.circ_number.cell.refresh()
*               MainFaultRow.ref_addr.cell.refresh()
*               MainFaultRow.fault_category.cell.refresh()
*               MainFaultRow.fault_type.cell.refresh()
*                   
****************************************************************************/
function Refresh_main_fault_row()
{
    /*--%r
     * set status to OK
     * IF the browser supports dynamic refresh
     *     refresh the location (Note this is common for PLC or I/O 
     *         fault table).
     *     IF the fault table type is PLC
     *         refresh the fault_description
     *     ELSE the fault table type is I/O
     *         refresh the circuit number
     *         refresh the reference address
     *         refresh the fault category
     *         refresh the fault type
     *     ENDIF the fault table type is PLC
     *     refresh the fault date/time
     * ELSE the browser supports does not support dynamic refresh
     *     set the status to ERROR
     * ENDIF the browser supports dynamic refresh
     * return status    
     */
    var status = OK;
    if (browser_refresh)
    {
        this.location.cell.refresh();
        if (this.type == "PLC")
        {
            this.fault_description.cell.refresh();
        }
        else
        {
            this.circ_number.cell.refresh();
            this.ref_addr.cell.refresh();
            this.fault_category.cell.refresh();
            this.fault_type.cell.refresh();
        }
        this.fault_date_time.cell.refresh();
    }
    else
    {
        status = ERROR;
    }
    return status;            
}

/*--%r**************************************************************************
* Function    : Create_main_fault_row_HTML
*
* Description : This method creates the HTML output for one 
*               main fault row.    
*
* Associated
*  Method     : MainFaultRow.createHTML()
*
* Inputs      : None.
*
* Outputs     : None. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : MainFaultRow.location.createHTML()
*               MainFaultRow.fault_description.createHTML()
*               MainFaultRow.fault_date_time.createHTML()
*               MainFaultRow.circ_number.createHTML()
*               MainFaultRow.ref_addr.createHTML()
*               MainFaultRow.fault_category.createHTML()
*               MainFaultRow.fault_type.createHTML()
*                   
****************************************************************************/
function Create_main_fault_row_HTML()
{
    /*--%r
     * create HTML output for the beginning of the row using the row_name
     *         property
     * create the HTML output for the location (Note this is common for PLC or I/O 
     *         fault table).
     * IF the fault table type is PLC
     *     create HTML output for the fault_description
     * ELSE the fault table type is I/O
     *     create HTML output for the circuit number
     *     create HTML output for the reference address
     *     create the HTML output for the fault category
     *     create the HTML output for the fault type
     * ENDIF the fault table type is PLC
     * create the HTML output for the fault date/time
     * create the HTML output for the end of the row    
     */
    document.write('<tr id="' + this.row_name + '" bgcolor="white">');
    this.location.createHTML();
    if (this.type == "PLC")
    {
        this.fault_description.createHTML();
    }
    else
    {
        this.circ_number.createHTML();
        this.ref_addr.createHTML();
        this.fault_category.createHTML();
        this.fault_type.createHTML();
    }
    this.fault_date_time.createHTML();
    document.write('</tr>');
}

/*--%r**************************************************************************
* Function    : Create_extra_fault_row_HTML
*
* Description : This method instructs the object to create the HTML for the 
*               extra fault row portion of the screen.    
*
* Associated
*  Method     : ExtraFaultRow.createHTML()
*
* Inputs      : None.
*
* Outputs     : None. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : ExtraFaultRow.long_short.createHTML()
*               ExtraFaultRow.task.createHTML()
*               ExtraFaultRow.group.createHTML()
*               ExtraFaultRow.action.createHTML()
*               ExtraFaultRow.error_code.createHTML()
*               ExtraFaultRow.fault_extra_data.createHTML()
*               ExtraFaultRow.io_bus.createHTML()
*               ExtraFaultRow.bus.createHTML()
*               ExtraFaultRow.point.createHTML()
*               ExtraFaultRow.fault_category_number.createHTML()
*               ExtraFaultRow.fault_type_number.createHTML()
*                   
****************************************************************************/
function Create_extra_fault_row_HTML()
{
    /*--%r
     * create HTML output for the start row using the row_name, the cell to hold 
     *         the extra fault table, the start of the tables to hold the  
     *         extra fault table
     * IF the fault table type is PLC
     *     create the header row for the PLC extra fault data (long_short, group, 
     *             action, error_code)
     *     create the HTML output for the long_short cell
     *     creat the HTML output for the task cell
     *     create HTML output for the group cell
     *     create HTML output for the action cell
     *     create HTML output for the error_code cell
     *     create HTML output for the end of row
     *     create the HTML output for the start of next row
     *     create the HTML output for the extra fault header cell
     *     create the HTML output for the extra fault data cell
     *     create the HTML output for the end of row
     * ELSE the fault table type is I/O
     *     create the header row for the I/O extra fault data (long_short, io_bus, 
     *             bus, point, group, action, category, type)
     *     create the HTML output for the long_short cell
     *     create the HTML output for the io_bus cell
     *     create the HTML output for the bus cell
     *     create the HTML output for the point cell
     *     create the HTML output for the group cell
     *     create the HTML output for the action cell
     *     create the HTML output for the category cell
     *     create the HTML output for the type cell
     *     create HTML output for the end of row
     *     create the HTML output for the start of next row
     *     create the HTML output for the extra fault header cell
     *     create the HTML output for the extra fault data cell
     *     create the HTML output for the end of row
     * ENDIF the fault table type is PLC
     * create HTML output for end of tables, end of cell, end of row   
     */
    var collapsed; /*--%r holds style name which determines whether the extra fault row is
                    *     collapsed (hidden) or expanded (shown) */
    if (this.show_fault)
    {
        collapsed = "clsExpanded";
    }
    else
    {
        collapsed = "clsCollapsed";
    }        
    document.write('<tr>');
    if (this.type == "PLC")
    {
        with (document)
        {
            write('<td colspan=3 bgcolor=white>');
            write('<DIV id="' + this.row_name +  '" class="' + collapsed + '">');
            write('<table border=0 width=100% cellspacing=0 cellpadding=0>');
            /*--%r#if debug */
            log_event("before getting image");  
            /*--%r#endif */
            write('<td align="left" valign="top"><img src="expand.gif"></td>');
            /*--%r#if debug */
            log_event("after getting image");  
            /*--%r#endif */
            write('<td>');
            write('<table border="1" bgcolor="white" valign="top" cellspacing="0" width=95% align="left" cellpadding="1" bgcolor="#FCFEDA">');
            write('<tr>');
            write('<TD width=150 class="ExtraInfoHeader">' + LONG_SHORT_LABEL + '</TD>');
            write('<TD width=150 class="ExtraInfoHeader">' + TASK_LABEL + '</TD>');
            write('<TD width=150 class="ExtraInfoHeader">' + GROUP_LABEL + '</TD>');
            write('<TD width=150 class="ExtraInfoHeader">' + ACTION_LABEL + '</TD>');
            write('<TD width=150 class="ExtraInfoHeader">' + ERROR_CODE_LABEL + '</TD>');
            write('</tr><tr>');
            /*--%r#if debug */
            log_event("creating extra row cells");
            /*--%r#endif */
            this.long_short.createHTML();
            this.task.createHTML();
            this.group.createHTML();
            this.action.createHTML();
            this.error_code.createHTML();
            write('</tr><tr>');
            write('<TD class="ExtraInfoHeader">' + FAULT_EXTRA_DATA_LABEL2 + '</TD>');
            this.fault_extra_data.createHTML();
            /*--%r#if debug */
            log_event("before closing extra fault tables");
            /*--%r#endif */
            write('</tr></TABLE></td></table></DIV></td></tr>');
            /*--%r#if debug */
            log_event("after closing extra fault tables");
            /*--%r#endif */
        }
    }
    else
    {
        with (document)
        {
            write('<td colspan=6 bgcolor=white>');
            write('<DIV id="' + this.row_name + '" class="' + collapsed + '">');  
            write('<table border=0 width=100% cellspacing=0 cellpadding=0>');
            write('<td align="left" valign="top"><img src="expand.gif"></td>');
            write('<td>');
            write('<table border="1" bgcolor="white" valign="top" cellspacing="0" width=100% align="left" cellpadding="1" bgcolor="#FCFEDA">');
            write('<tr>');
            write('<TD width=112 class="ExtraInfoHeader">' + LONG_SHORT_LABEL + '</TD>');
            write('<TD width=73 class="ExtraInfoHeader">' + IO_BUS_LABEL + '</TD>');
            write('<TD width=73 class="ExtraInfoHeader">' + BUS_LABEL + '</TD>');
            write('<TD width=73 class="ExtraInfoHeader">' + POINT_LABEL + '</TD>');
            write('<TD width=73 class="ExtraInfoHeader">' + GROUP_LABEL + '</TD>');
            write('<TD width=73 class="ExtraInfoHeader">' + ACTION_LABEL + '</TD>');
            write('<TD width=73 class="ExtraInfoHeader">' + CATEGORY_LABEL + '</TD>');
            write('<TD width=73 class="ExtraInfoHeader">' + TYPE_LABEL + '</TD>');
            write('</tr><tr>');
            /*--%r#if debug */
            log_event("creating extra row cells");
            /*--%r#endif */
            this.long_short.createHTML();
            this.io_bus.createHTML();
            this.bus.createHTML();
            this.point.createHTML();
            this.group.createHTML();
            this.action.createHTML();
            this.fault_category_number.createHTML();
            this.fault_type_number.createHTML();
            write('</tr><tr>');
            write('<TD class="ExtraInfoHeader">' + FAULT_EXTRA_DATA_LABEL2 + '</TD>');
            this.fault_extra_data.createHTML();
            write('</tr></TABLE></td></table><br></DIV></td></tr>');
        }
    }             
}

/*--%r**************************************************************************
* Function    : Refresh_extra_fault_row
*
* Description : The purpose of this method is to dynamically update the extra 
*               fault row data from the PLC.    
*
* Associated
*  Method     : ExtraFaultRow.refresh()
*
* Inputs      : None.
*
* Outputs     : Returns OK if the browser supports dynamic refresh.  Otherwise, 
*               it returns ERROR. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : ExtraFaultRow.long_short.refresh()
*               ExtraFaultRow.task.refresh()
*               ExtraFaultRow.group.refresh()
*               ExtraFaultRow.action.refresh()
*               ExtraFaultRow.error_code.refresh()
*               ExtraFaultRow.fault_extra_data.refresh()
*               ExtraFaultRow.io_bus.refresh()
*               ExtraFaultRow.bus.refresh()
*               ExtraFaultRow.point.refresh()
*               ExtraFaultRow.fault_category_number.refresh()
*               ExtraFaultRow.fault_type_number.refresh()
*                   
****************************************************************************/
function Refresh_extra_fault_row()
{
    /*--%r
     * set the status to OK
     * IF the browser supports dynamic refresh
     *     update the display for the long_short cell
     *     IF the fault table type is PLC
     *         update the display for the task cell
     *         update the display for the group cell
     *         update the display for the action cell
     *         update the display for the error_code cell
     *     ELSE the fault table type is I/O
     *         update the display for the io_bus cell
     *         update the display for the bus cell
     *         update the display for the point cell
     *         update the display for the group cell
     *         update the display for the action cell
     *         update the display for the category cell
     *         update the display for the type cell
     *     ENDIF the fault table type is PLC
     *     update the display for the extra fault data cell
     * ELSE the browser does not support dynamic refresh
     *     set status to ERROR
     * ENDIF the browser supports dynamic refresh
     * return status   
     */
    var status = OK;
    if (browser_refresh)
    {
        this.long_short.cell.refresh();
        if (this.type == "PLC")
        {
            this.task.cell.refresh();
            this.group.cell.refresh();
            this.action.cell.refresh();
            this.error_code.cell.refresh();
        }
        else
        {
            this.io_bus.cell.refresh();
            this.bus.cell.refresh();
            this.point.cell.refresh();
            this.group.cell.refresh();
            this.action.cell.refresh();
            this.fault_category_number.cell.refresh();
            this.fault_type_number.cell.refresh();
        }
        this.fault_extra_data.refresh();
    }
    else
    {
        status = ERROR;
    }
    return status;
}


/*--%r**************************************************************************
* Function    : Show_extra_fault
*
* Description : The purpose of this method is to show or hide the extra fault 
*               table row.    
*
* Associated
*  Method     : ExtraFaultRow.show()
*
* Inputs      : value - if set to true, the extra fault row is shown.  If set to 
*                   false the extra fault row is hidden.
*
* Outputs     : Returns OK if the browser supports dynamic refresh.  Otherwise, 
*               it returns ERROR. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Show_extra_fault(value)
{
    /*--%r
     * set the status to OK
     * IF the browser supports dynamic refresh
     *     get the HTML element with this row's name
     *     IF the element is found
     *         IF the value is true indicating to show the extra fault row
     *             expand the row by changing the class style for the row to expand
     *         ELSE the value is false ...
     *             collapse the row by changing the class style for the row to collapse
     *         ENDIF the value is true indicating to show the extra fault row
     *         set the show_fault property to equal "value" 
     * ELSE the browser does not support dynamic refresh
     *     set status to ERROR
     * ENDIF the browser supports dynamic refresh
     * return status   
     */
    var status = OK;
    if (browser_refresh)
    {
        var ExtraElement = document.all(this.row_name);
        if (ExtraElement)
        {
            if (value == true) 
        	{
        	    ExtraElement.className="clsExpanded";
        	}
        	else 
        	{
        	    ExtraElement.className="clsCollapsed";
        	}
        	this.show_fault = value;
        }
    }
    else
    {
        status = ERROR;
    }
    return status;        	    
}

/*--%r**************************************************************************
* Function    : Create_main_fault_cell_HTML
*
* Description : This method instructs the object to create the HTML for a 
*               main fault cell.   
*
* Associated
*  Method     : MainFaultCell.createHTML()
*
* Inputs      : None.
*
* Outputs     : None. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Create_main_fault_cell_HTML()
{
    /*--%r
     * create the HTML output for the main fault cell based on the cell's 
     *         cell_name and value   
     */ 
    document.write('<td class="' + this.style + '" id="' + this.cell.cell_name + '">' + this.cell.value + '</td>');
     
}

/*--%r**************************************************************************
* Function    : Create_extra_fault_cell_HTML
*
* Description : This method creates the HTML output for an  
*               extra fault cell.   
*
* Associated
*  Method     : ExtraFaultCell.createHTML()
*
* Inputs      : None.
*
* Outputs     : None. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Create_extra_fault_cell_HTML()
{
    /*--%r
     * create the HTML output for the extra fault cell based on the cell's 
     *         cell_name and value   
     */
    document.write('<TD class="ExtraInfo" id="' + this.cell.cell_name + '">' + this.cell.value + '</TD>');
     
}

/*--%r**************************************************************************
* Function    : Create_extra_fault_data_cell_HTML
*
* Description : This method creates the HTML for an  
*               extra fault data cell.  This cell is slightly different
*               because the value in the cell must be formatted as
*               BYTE, WORD, or ASCII.   
*
* Associated
*  Method     : ExtraFaultDataCell.createHTML()
*
* Inputs      : None.
*
* Outputs     : None. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Create_extra_fault_data_cell_HTML()
{
    /*--%r
     * create the HTML output for the extra fault data cell based on the cell's 
     *         cell_name and foramtted value   
     */
    if (this.type == "PLC")
    {
        document.write('<td colspan=4 class="ExtraInfo" id="' + this.cell_name + '">' + getExtraFaultDataFormat(this.format, this.value) + '</td>');
    }
    else
    {
        document.write('<td colspan=7 class="ExtraInfo" id="' + this.cell_name + '">' + getExtraFaultDataFormat(this.format, this.value) + '</td>');
    } 
}

/*--%r**************************************************************************
* Function    : Refresh_extra_fault_data_cell_HTML
*
* Description : This method updates the user's screen with the value.  This 
*               cell is slightly different because the value in the cell must 
*               be formatted as BYTE, WORD, or ASCII.   
*
* Associated
*  Method     : ExtraFaultDataCell.refresh()
*
* Inputs      : None.
*
* Outputs     : returns OK if the browser supports dynamic refresh and ERROR 
*               otherwise. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Refresh_extra_fault_data_cell_HTML()
{
    /*--%r
     * set the status to OK
     * IF the browser supports dynamic refresh
     *     using the cell_name, format and value property, update the cell display
     * ELSE the browser does not support dynamic refresh
     *     set the status to ERROR
     * ENDIF the browser supports dynamic refresh
     * return status   
     */
    var status = OK;
    if (browser_refresh)
    {
        document.all(this.cell_name).innerText = getExtraFaultDataFormat(this.format, this.value);
    }
    else
    {
        status = ERROR;
    }
    return status;       
}

/*--%r**************************************************************************
* Function    : Set_value
*
* Description : This method checks the new_value and sets the value property 
*               with new_value if it is valid.   
*
* Associated
*  Method     : Cell.setValue()
*
* Inputs      : new_value  the value to use when setting the value property.
*
* Outputs     : OK if the new value is valid and ERROR otherwise. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Set_value(new_value)
{
    /*--%r
     * set the status to OK
     * set the value property equal to the new_value (Note: currently there
     *    are no parameters that need to be checked for validity)
     * return status  
     */
    var status = OK;
    this.value = new_value;
    return status;     
}

/*--%r**************************************************************************
* Function    : Set_extra_fault_data_cell_value
*
* Description : This method checks the new_value and sets the value property 
*               with new_value if it is valid.   
*
* Associated
*  Method     : ExtraFaultDataCell.setValue
*
* Inputs      : new_value  the value to use when setting the value property.
*
* Outputs     : OK if the new value is valid and ERROR otherwise. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Set_extra_fault_data_cell_value(new_value)
{
    /*--%r 
     * set the status to OK
     * IF the new value does not equal the default value
     *     break up the extra fault data into individual bytes
     *     FOR each byte
     *       IF the byte element is not a number
     *           set the status to ERROR
     *           break
     *       ENDIF the byte element is not a number
     *     ENDFOR each byte
     * ENDIF the new value does not equal the default value 
     * IF the status is OK 
     *     set the value property equal to the new_value 
     * ENDIF the status is OK 
     * return status  
     */
    var status = OK;
    if (new_value != DEFAULT_VALUE)
    {
        var value_parse_array = new_value.split(EXTRA_FAULT_DATA_SEP);
        for (var i = 0; i < value_parse_array.length; i++)
        {
            if (isNaN(parseInt(value_parse_array[i],16)))
            {
                status = ERROR;
                break;
            }
        }
    }        
    if (status == OK)
    {       
        this.value = new_value;
    }    
    return status;     
}
/*--%r**************************************************************************
* Function    : Set_format_extra_fault_data_cell
*
* Description : This method checks the new_format and sets the format property 
*               with new_format if it is valid.   
*
* Associated
*  Method     : ExtraFaultDataCell.setFormat
*
* Inputs      : new_format  the value to use when setting the format property.
*
* Outputs     : OK if the new format is valid and ERROR otherwise. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Set_format_extra_fault_data_cell(new_format)
{
    /*--%r
     * set the status to OK
     * IF the new_format is BYTE, WORD, or ASCII
     *     set the format property equal to the new_format
     * ELSE the new_format is invalid
     *     set the status to ERROR
     * ENDIF the new_format is BYTE, WORD, or ASCII
     * return status  
     */
    var status = OK;
    if ((new_format == BYTE)||(new_format == WORD)||(new_format == ASCII))
    {
        this.format = new_format;
    }
    else
    {
        status = ERROR;
    }
    return status;              
}

/*--%r**************************************************************************
* Function    : Refresh_cell
*
* Description : The purpose of this method is to dynamically update the 
*               screen with the current value contained in the value property 
*               of this object.   
*
* Associated
*  Method     : Cell.refresh
*
* Inputs      : None.
*
* Outputs     : Returns OK if the browser supports dynamic refresh and 
*               ERROR otherwise. 
*
* Global Data
* & Objects
* Accessed    : None
*
* Modified
* Global Data
* & Objects   : None.
*                   
****************************************************************************/
function Refresh_cell()
{
    /*--%r
     * set the status to OK
     * IF the browser supports dynamic refresh
     *     using the cell_name and value, update the cell on the user's screen
     * ELSE the browser does not support dynamic refresh
     *     set the status to ERROR
     * ENDIF the browser supports dynamic refresh
     * return status  
     */
    var status = OK;
    if (browser_refresh)
    {
        document.all(this.cell_name).innerText = this.value;
        if (this.value == "" || this.value == ".")
            document.all(this.cell_name).style.color = "white";
        else
            document.all(this.cell_name).style.color = "black";        
    }
    else
    {
        status = ERROR;
    }
    return status;            
}

/*--%r Class Declaration Section */

/*--%r Note - Class method definitions are defined in the function definition section 
*      where the corresponding function name has the first letter of the first word 
*      is capitalized and the remaining words are lower case with an underscore between 
*      the words.
*/

/*--%r**************************************************************************
* Class       : Fault
*
* Description : The purpose of this class is to hold and display all the fault 
*               information for either the PLC or I/O fault table.
*
* Init Inputs : type  determines whether the fault object is a PLC type or I/O type.  
*                   The values are "PLC" or "IO" with "PLC" being the default 
*               num_of_rows  - this determines the number of faultTable rows to create.
*
* Properties  : type - as defined above
*               faultSummary -  This element is an instance of the FaultSummary 
*                   object described later in this file.
*               faultTable -  This element is an instance of the FaultTable object 
*                   described later in this file.
*               extraFaultControl -  This element is an instance of the 
*                   ExtraFaultControl object described later in this file.
*
* Methods     : createHTML()
*               setAllFaults()
*               getAllFaults()
*               refresh()
*               highlight()
*               toggleExtraFaultDisplay()
*               changeExtraFaultDisplay()
*               changeExtraFaultFormat()
*
****************************************************************************/
function Fault(type, num_of_rows)
{
    /*--%r Create and Initialize properties */
    this.type = type;
    this.faultSummary = new FaultSummary();
    this.faultTable = new FaultTable(type, num_of_rows);
    this.extraFaultControl = new ExtraFaultControl();

    /*--%r Create and initialize methods */
    this.createHTML = Create_HTML;
    this.setAllFaults = Set_all_faults;
    this.getAllFaults = Get_all_faults;
    this.refresh = Refresh_fault;
    this.highlight = Highlight;
    this.toggleExtraFaultDisplay = Toggle_extra_fault_display;
    this.changeExtraFaultDisplay = Change_extra_fault_display;
    this.changeExtraFaultFormat = Change_extra_fault_format;
}

/*--%r**************************************************************************
* Class       : FaultSummary
*
* Description : The purpose of this class is to hold and display the fault summary 
*               information for either the PLC or I/O fault table.
*
* Init Inputs : None.
*
* Properties  : total_faults - This indicates the total number of faults detected 
*                   by the PLC.
*               num_of_fault_entries -  This property represents the number of 
*                   fault table entries currently in the PLC. 
*               fault_table_cleared_time -  This property indicates the date 
*                   and time when the fault table in the PLC was last cleared by 
*                   the user
*               PLC_date_time -  This property represents the PLCs date when the 
*                   fault table was requested.
*               entries_overflowed - this represents the faults that occurred but
*                   that are no longer in the PLC's fault table.  It equals the 
*                   total_faults minus the num_of_fault_entries.
*
* Methods     : createHTML()
*               refresh()
*
****************************************************************************/
function FaultSummary()
{
    /*--%r Create and Initialize properties */
    this.total_faults = new FaultSummaryCell(TOTAL_FAULTS_CELL_NAME);
    this.num_of_fault_entries = new FaultSummaryCell(NUM_OF_FAULT_ENTRIES_CELL_NAME);    
    this.fault_table_cleared_time = new FaultSummaryCell(FAULT_TABLE_CLEARED_TIME_CELL_NAME);
    this.PLC_date_time = new FaultSummaryCell(PLC_DATE_TIME_CELL_NAME);
    this.entries_overflowed = new FaultSummaryCell(ENTRIES_OVERFLOWED_CELL_NAME);
    
    /*--%r Create and initialize methods */
    this.createHTML = Create_fault_summary_HTML;
    this.refresh = Refresh_fault_summary;
}

/*--%r**************************************************************************
* Class       : FaultTable
*
* Description : The purpose of this class is to hold and display all the fault 
*               information for the table portion of the Fault object.
*
* Init Inputs : type  determines whether the fault object is a PLC type or I/O 
*                   type.  The values are "PLC" or "IO" with "PLC" being the 
*                   default. 
*               num_of_rows  - this determines the number of rows to create.
*
* Properties  : type -   As described above.
*               num_of_rows -  As described above.
*               mainFaultRow -   This property contains multiple  instances 
*                   of the MainFaultRow object described later in this document.
*               extraFaultRow -   This property contains multiple  instances 
*                   of the ExtraFaultRow object described later in this document.
*
* Methods     : createHTML()
*               setRow()
*               getRow()
*               refresh()
*
****************************************************************************/
function FaultTable(type, num_of_rows)
{
    /*--%r Create and Initialize properties */
    this.type = type;
    this.num_of_rows = num_of_rows;
    this.mainFaultRow = new Array(num_of_rows);
    for (var i = 0; i < num_of_rows; i++)
    {
        this.mainFaultRow[i] = new MainFaultRow(type, i.toString());
    }
    this.extraFaultRow = new Array(num_of_rows);
    for (i = 0; i < num_of_rows; i++)
    {
        this.extraFaultRow[i] = new ExtraFaultRow(type, i.toString());
    }

    /*--%r Create and initialize methods */
    this.createHTML = Create_fault_table_HTML;
    this.setRow = Set_row;
    this.getRow = Get_row;
    this.refresh = Refresh_fault_table;
}

/*--%r**************************************************************************
* Class       : ExtraFaultControl
*
* Description : The purpose of this class is to hold and display the elements 
*               that allow the user to control whether to display the extra fault 
*               information and also to control the format of the extra data 
*               (BYTE, WORD, ASCII).
*
* Init Inputs : None.
*
* Properties  : show_all -    This property indicates whether the fault extra 
*                   data should be displayed.
*               format -   This property determines whether the extra fault 
*                   data is displayed in byte, word or ASCII mode.
*               HTML_created -  This property is set after the HTML output 
*                   has been produced by the ExtraFaultControl object.  The 
*                   property is used by the methods of this class to determine 
*                   when they can access form elements created with the 
*                   createHTML method.
*
* Methods     : createHTML()
*               setShowAll()
*               getShowAll()
*               setFormat()
*               getFormat()
*               setFromCookie()
*               storeToCookie()
*
****************************************************************************/
function ExtraFaultControl()
{
    /*--%r Create and Initialize properties */
    this.show_all = false;
    this.format = BYTE;
    this.HTML_created = false;

    /*--%r Create and initialize methods */
    this.createHTML = Create_extra_fault_control_HTML;
    this.setShowAll = Set_show_all;
    this.getShowAll = Get_show_all;
    this.setFormat = Set_format;
    this.getFormat = Get_format;
    this.setFromCookie = Set_from_cookie;
    this.storeToCookie = Store_to_cookie;
}

/*--%r**************************************************************************
* Class       : FaultSummaryCell
*
* Description : The purpose of this class is to hold values for and display 
*               elements of the Fault Summary table.
*
* Init Inputs : cell_name  this is the name used to reference the cell when 
*                   it needs to be dynamically refreshed.
*
* Properties  : cell   This property holds the value and contains methods 
*                   for refreshing and setting the value.
*
* Methods     : createHTML()
*
****************************************************************************/
function FaultSummaryCell(cell_name)
{
    /*--%r Create and Initialize properties */
    this.cell = new Cell(cell_name);

    /*--%r Create and initialize methods */
    this.createHTML = Create_fault_summary_cell_HTML;
}

/*--%r**************************************************************************
* Class       : MainFaultRow
*
* Description : The purpose of this class is to hold and display the main fault 
*               data for one fault in the PLC
*
* Init Inputs : type  determines whether the row will contain values for a 
*                   PLC fault or an I/O fault.
*               row_index - indicates which row is being created.  This is 
*                   used to give a unique name to each cell.
*
* Properties  : type -  As previously defined in the initialization section.
*               row_name - a name to associate with the HTML row element which 
*                   is used for referencing the row to change it's appearance
*                   when a mouse event occurs.
*               location -  This property indicates the location of the fault
*                   specified as rack and slot number.
*               fault_description -  This property contains the fault description.
*               fault_date_time -  This property contains the date and time when 
*                   the fault occurred.
*               circ_number -  This property contains the date and time when the 
*                   fault occurred.
*               ref_addr -  This property contains the reference address associated 
*                   with the fault.
*               fault_category -  This property contains the fault category for the 
*                   fault.
*               fault_type -  This property contains the fault type for the fault.
*
* Methods     : createHTML()
*               refresh()
*
****************************************************************************/
function MainFaultRow(type, row_index)
{
    /*--%r Create and Initialize properties */
    this.type = type;
    this.row_name = MAIN_FAULT_ROW_NAME + row_index;
    this.location = new MainFaultCell(LOCATION_CELL_NAME+ row_index,"faultStyle2");
    this.fault_description = new MainFaultCell(FAULT_DESCRIPTION_CELL_NAME + row_index,"faultStyle1");
    this.fault_date_time = new MainFaultCell(FAULT_DATE_TIME_CELL_NAME + row_index,"faultStyle1");
    this.circ_number = new MainFaultCell(CIRC_NUMBER_CELL_NAME + row_index,"faultStyle2");
    this.ref_addr = new MainFaultCell(REF_ADDR_CELL_NAME + row_index, "faultStyle2");
    this.fault_category = new MainFaultCell(FAULT_CATEGORY_CELL_NAME + row_index, "faultStyle1");
    this.fault_type = new MainFaultCell(FAULT_TYPE_CELL_NAME + row_index, "faultStyle2");
    
    /*--%r Create and initialize methods */
    this.createHTML = Create_main_fault_row_HTML;
    this.refresh = Refresh_main_fault_row;
}

/*--%r**************************************************************************
* Class       : ExtraFaultRow
*
* Description : The purpose of this class is to hold and display the extra 
*               fault data for one fault table entry from the PLC.
*
* Init Inputs : type  determines whether the row will contain values for a 
*                   PLC fault or an I/O fault.
*               row_index - indicates which row is being created.  This is 
*                   used to give a unique name to each cell.
*
* Properties  : type -  As previously defined in the initialization section.
*               row_name - a name to associate with the HTML row element which 
*                   is used for referencing the row to change it's appearance
*                   when a mouse event occurs.
*               show_fault - indicates whether the extra fault row is shown or 
*                   hidden (true = show, false = hide).
*               long_short -  contains the long/short value for a fault.
*               task - contains the task value for a fault.
*               group -  contains the group value for a fault.
*               action -  contains the action value for a fault.
*               error_code -  contains the error code value for a fault.
*               fault_extra_data -  contains the fault_extra_data value for a 
*                   fault. This property is slightly difference since it has
*                   a format property, as setFormat method and during refresh
*                   the displayed value is based on the value and the format.
*               io_bus -  contains the I/O bus value for a fault.
*               bus	- contains the bus value for a fault.
*               point -  contains the point value for a fault.
*               fault_category_number - contains the fault category number value 
*                   for a fault.
*               fault_type_number - contains the fault type number value for 
*                   a fault.

* Methods     : createHTML()
*               refresh()
*               show()
*
****************************************************************************/
function ExtraFaultRow(type, row_index)
{
    /*--%r Create and Initialize properties */
    this.type = type;
    this.row_name = EXTRA_FAULT_ROW_NAME + row_index;
    this.show_fault = false;
    this.long_short = new ExtraFaultCell(type, LONG_SHORT_CELL_NAME + row_index);
    this.task= new ExtraFaultCell(type, TASK_CELL_NAME + row_index);
    this.group= new ExtraFaultCell(type, GROUP_CELL_NAME + row_index);
    this.action= new ExtraFaultCell(type, ACTION_CELL_NAME + row_index);
    this.error_code= new ExtraFaultCell(type, ERROR_CODE_CELL_NAME + row_index);
    this.fault_extra_data = new ExtraFaultDataCell(type, FAULT_EXTRA_DATA_CELL_NAME + row_index);
    this.io_bus= new ExtraFaultCell(type, IO_BUS_CELL_NAME + row_index);
    this.bus= new ExtraFaultCell(type, BUS_CELL_NAME + row_index);
    this.point= new ExtraFaultCell(type, POINT_CELL_NAME + row_index);
    this.fault_category_number = new ExtraFaultCell(type, FAULT_CATEGORY_NUMBER_CELL_NAME + row_index);
    this.fault_type_number= new ExtraFaultCell(type, FAULT_TYPE_NUMBER_CELL_NAME + row_index);
        
    /*--%r Create and initialize methods */
    this.createHTML = Create_extra_fault_row_HTML;
    this.refresh = Refresh_extra_fault_row;
    this.show = Show_extra_fault;
}

/*--%r**************************************************************************
* Class       : MainFaultCell
*
* Description : The purpose of this class is to hold and display one piece of 
*               information for a fault such as the fault description.
*
* Init Inputs : cell_name  determines the name of the cell, which is needed 
*               as reference when refreshing the cell with updated fault data.
*               style_name - determines the style to use for displaying the cell.
*
* Properties  : cell -  This property holds the value for the cell, the name 
*                   of the cell for referencing the cell dynamically and 
*                   methods for changing the value and for refreshing the 
*                   screen with new values.
*               style_name - as specified in the init inputs section.
*
* Methods     : createHTML()
*
****************************************************************************/
function MainFaultCell(cell_name, style_name)
{
    /*--%r Create and Initialize properties */
    this.cell = new Cell(cell_name);
    this.style = style_name;
        
    /*--%r Create and initialize methods */
    this.createHTML = Create_main_fault_cell_HTML;
}

/*--%r**************************************************************************
* Class       : ExtraFaultCell
*
* Description : The purpose of this class is to hold and display one piece of 
*               information for a fault such as the fault description.
*
* Init Inputs : type - indicates whether the fault table is a PLC or I/O fault
*                   table.  The cell needs to know this when creating HTML
*                   for the extra Fault row since there are more I/O fault
*                   parameters.
*               cell_name  determines the name of the cell, which is needed 
*               as reference when refreshing the cell with updated fault data.
*
* Properties  : type - as specified in the init input section above.
*               cell -  This property holds the value for the cell, the name 
*                   of the cell for referencing the cell dynamically and 
*                   methods for changing the value and for refreshing the 
*                   screen with new values.
*
* Methods     : createHTML()
*
****************************************************************************/
function ExtraFaultCell(type, cell_name)
{
    /*--%r Create and Initialize properties */
    this.type = type;
    this.cell = new Cell(cell_name);
        
    /*--%r Create and initialize methods */
    this.createHTML = Create_extra_fault_cell_HTML;
}

/*--%r**************************************************************************
* Class       : ExtraFaultDataCell
*
* Description : The purpose of this class is to hold the fault extra data.  
*               This is cell is different from the other cells because
*               extra fault data can be formatted into BYTE, WORD or ASCII
*               so the display needs to be handled differently
*
* Init Inputs : type - indicates whether the fault table is a PLC or I/O fault
*                   table.  The cell needs to know this when creating HTML
*                   for the extra Fault row since there are more I/O fault
*                   parameters.
*               cell_name  determines the name of the cell, which is needed 
*                   as a reference when refreshing the cell with updated fault data.
*
* Properties  : type - as specified in the init input section above.
*               cell_name - as specified in the init input section above.
*               value - the value associated with the particular fault cell
*               format - indicates the current format when displaying the
*                    fault extra data cell value.  The possible values are BYTE, WORD
*                    or ASCII.
*
* Methods     : createHTML()
*               refresh()
*               setValue()
*               setFormat()
*
****************************************************************************/
function ExtraFaultDataCell(type, cell_name)
{
    /*--%r Create and Initialize properties */
    this.type = type;
    this.cell_name = cell_name;
    this.value = DEFAULT_VALUE;
    this.format = BYTE;
        
    /*--%r Create and initialize methods */
    this.createHTML = Create_extra_fault_data_cell_HTML;
    this.refresh = Refresh_extra_fault_data_cell_HTML;
    this.setValue = Set_extra_fault_data_cell_value;
    this.setFormat = Set_format_extra_fault_data_cell;
}

/*--%r**************************************************************************
* Class       : Cell
*
* Description : The purpose of this class is to hold the value of and refresh 
*               the display of individual fault table cell elements.
*
* Init Inputs : cell_name  determines the name of the cell, which is needed 
*               as reference when refreshing the cell with updated fault data.
*
* Properties  : cell_name - as defined in the init input section.
*               value -  This property holds the value for the cell in the 
*                   fault table.
*
* Methods     : setValue()
*               refresh()
*
****************************************************************************/
function Cell(cell_name)
{
    /*--%r Create and Initialize properties */
    this.value = DEFAULT_VALUE;
    this.cell_name = cell_name;
        
    /*--%r Create and initialize methods */
    this.setValue = Set_value;
    this.refresh = Refresh_cell;
}

/*--%r**********************************************************************
* Class       : GetFaultActionText
*
* Description : The purpose of this class is to return the action text that 
*               is associated with the Fault action number.
* Init Inputs : index : determines the action text of the cell.
*
*
* Methods     : isNaN() determines if the index is number of not.
****************************************************************************/

function GetFaultActionText(index)
{
    if ((index >= 0) && (index <= 2)) {
	return ":"+FaultActionText[index];
    }
    if(isNaN(index)){
       	return " ";
    }
    
	return "Unknown Fault Action Code";
} 